/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./constants.js":
/*!**********************!*\
  !*** ./constants.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Constants)
/* harmony export */ });
/* harmony import */ var _utils_util__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./utils/util */ "./utils/util.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A class containing constants used throughout the EasyPost Node.js client library.
 */
class Constants {
  static get CARRIER_ACCOUNTS_WITH_CUSTOM_WORKFLOWS() {
    return ['FedexAccount', 'FedexSmartpostAccount', 'UpsAccount'];
  }
}
_defineProperty(Constants, "EXTERNAL_API_CALL_FAILED", 'Communication with %s failed, please try again later');
_defineProperty(Constants, "INVALID_API_KEY_TYPE", 'Invalid API key type.');
_defineProperty(Constants, "INVALID_PARAMETER", 'Invalid parameter: %s.');
_defineProperty(Constants, "INVALID_PAYMENT", 'The chosen payment method is not a credit card. Please try again.');
_defineProperty(Constants, "INVALID_WEBHOOK_SIGNATURE", 'Webhook does not contain a valid HMAC signature.');
_defineProperty(Constants, "MISSING_REQUIRED_PARAMETER", 'Missing required parameter: %s.');
_defineProperty(Constants, "NO_OBJECT_FOUND", 'No %s found.');
_defineProperty(Constants, "NO_PAYMENT_METHODS", 'No payment methods are set up. Please add a payment method and try again.');
_defineProperty(Constants, "API_DID_NOT_RETURN_ERROR_DETAILS", 'API did not return error details.');
_defineProperty(Constants, "WEBHOOK_DOES_NOT_MATCH", 'Webhook received did not originate from EasyPost or had a webhook secret mismatch.');
_defineProperty(Constants, "END_OF_PAGINATION", 'There are no more pages to retrieve.');
_defineProperty(Constants, "ERROR_DESERIALIZATION", 'Error deserializing JSON response');
_defineProperty(Constants, "Utils", new _utils_util__WEBPACK_IMPORTED_MODULE_0__["default"]());

/***/ }),

/***/ "./easypost.js":
/*!*********************!*\
  !*** ./easypost.js ***!
  \*********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DEFAULT_BASE_URL: () => (/* binding */ DEFAULT_BASE_URL),
/* harmony export */   DEFAULT_HEADERS: () => (/* binding */ DEFAULT_HEADERS),
/* harmony export */   DEFAULT_TIMEOUT: () => (/* binding */ DEFAULT_TIMEOUT),
/* harmony export */   METHODS: () => (/* binding */ METHODS),
/* harmony export */   MS_SECOND: () => (/* binding */ MS_SECOND),
/* harmony export */   SERVICES: () => (/* binding */ SERVICES),
/* harmony export */   "default": () => (/* binding */ EasyPostClient)
/* harmony export */ });
/* harmony import */ var os__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! os */ "os");
/* harmony import */ var os__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(os__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var superagent__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! superagent */ "superagent");
/* harmony import */ var superagent__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(superagent__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! uuid */ "uuid");
/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(uuid__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_json__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../package.json */ "../package.json");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./constants */ "./constants.js");
/* harmony import */ var _errors_error_handler__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./errors/error_handler */ "./errors/error_handler.js");
/* harmony import */ var _errors_general_missing_parameter_error__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./errors/general/missing_parameter_error */ "./errors/general/missing_parameter_error.js");
/* harmony import */ var _services_address_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./services/address_service */ "./services/address_service.js");
/* harmony import */ var _services_api_key_service__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./services/api_key_service */ "./services/api_key_service.js");
/* harmony import */ var _services_batch_service__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./services/batch_service */ "./services/batch_service.js");
/* harmony import */ var _services_beta_rate_service__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./services/beta_rate_service */ "./services/beta_rate_service.js");
/* harmony import */ var _services_beta_referral_customer_service__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./services/beta_referral_customer_service */ "./services/beta_referral_customer_service.js");
/* harmony import */ var _services_billing_service__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./services/billing_service */ "./services/billing_service.js");
/* harmony import */ var _services_carrier_account_service__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./services/carrier_account_service */ "./services/carrier_account_service.js");
/* harmony import */ var _services_carrier_metadata_service__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./services/carrier_metadata_service */ "./services/carrier_metadata_service.js");
/* harmony import */ var _services_carrier_type_service__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./services/carrier_type_service */ "./services/carrier_type_service.js");
/* harmony import */ var _services_customs_info_service__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./services/customs_info_service */ "./services/customs_info_service.js");
/* harmony import */ var _services_customs_item_service__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./services/customs_item_service */ "./services/customs_item_service.js");
/* harmony import */ var _services_end_shipper_service__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./services/end_shipper_service */ "./services/end_shipper_service.js");
/* harmony import */ var _services_event_service__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./services/event_service */ "./services/event_service.js");
/* harmony import */ var _services_insurance_service__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./services/insurance_service */ "./services/insurance_service.js");
/* harmony import */ var _services_order_service__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./services/order_service */ "./services/order_service.js");
/* harmony import */ var _services_parcel_service__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./services/parcel_service */ "./services/parcel_service.js");
/* harmony import */ var _services_pickup_service__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./services/pickup_service */ "./services/pickup_service.js");
/* harmony import */ var _services_rate_service__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./services/rate_service */ "./services/rate_service.js");
/* harmony import */ var _services_referral_customer_service__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./services/referral_customer_service */ "./services/referral_customer_service.js");
/* harmony import */ var _services_refund_service__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ./services/refund_service */ "./services/refund_service.js");
/* harmony import */ var _services_report_service__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ./services/report_service */ "./services/report_service.js");
/* harmony import */ var _services_scan_form_service__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! ./services/scan_form_service */ "./services/scan_form_service.js");
/* harmony import */ var _services_shipment_service__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! ./services/shipment_service */ "./services/shipment_service.js");
/* harmony import */ var _services_tracker_service__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! ./services/tracker_service */ "./services/tracker_service.js");
/* harmony import */ var _services_user_service__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! ./services/user_service */ "./services/user_service.js");
/* harmony import */ var _services_webhook_service__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! ./services/webhook_service */ "./services/webhook_service.js");
/* harmony import */ var _utils_util__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! ./utils/util */ "./utils/util.js");


































const util = __webpack_require__(/*! util */ "util");

/**
 * How many milliseconds in a second.
 * @type {number}
 */
const MS_SECOND = 1000;

/**
 * The default timeout for all EasyPost API requests.
 * @type {number}
 */
const DEFAULT_TIMEOUT = 60 * MS_SECOND;

/**
 * The default base URL for all production EasyPost API requests.
 * @type {string}
 */
const DEFAULT_BASE_URL = 'https://api.easypost.com/v2/';

/**
 * The default headers used for all EasyPost API requests.
 * @type {{'Accept': string, 'Content-Type': string, 'User-Agent': string}}
 */
const DEFAULT_HEADERS = {
  Accept: 'application/json',
  'Content-Type': 'application/json',
  'User-Agent': `EasyPost/v2 NodejsClient/${_package_json__WEBPACK_IMPORTED_MODULE_3__.version} Nodejs/${process.versions.node} OS/${os__WEBPACK_IMPORTED_MODULE_0___default().platform()} OSVersion/${os__WEBPACK_IMPORTED_MODULE_0___default().release()} OSArch/${os__WEBPACK_IMPORTED_MODULE_0___default().arch()}`
};

/**
 * A map of HTTP methods to their corresponding string values (for use with superagent).
 * @type {{DELETE: string, POST: string, GET: string, PUT: string, PATCH: string}}
 */
const METHODS = {
  GET: 'get',
  POST: 'post',
  PUT: 'put',
  PATCH: 'patch',
  DELETE: 'del'
};

/**
 * The services available for the client (end-user-facing name corresponding to a `BaseService`-based class).
 * @type {Map}
 */
const SERVICES = {
  Address: _services_address_service__WEBPACK_IMPORTED_MODULE_7__["default"],
  ApiKey: _services_api_key_service__WEBPACK_IMPORTED_MODULE_8__["default"],
  Batch: _services_batch_service__WEBPACK_IMPORTED_MODULE_9__["default"],
  BetaRate: _services_beta_rate_service__WEBPACK_IMPORTED_MODULE_10__["default"],
  BetaReferralCustomer: _services_beta_referral_customer_service__WEBPACK_IMPORTED_MODULE_11__["default"],
  Billing: _services_billing_service__WEBPACK_IMPORTED_MODULE_12__["default"],
  CarrierAccount: _services_carrier_account_service__WEBPACK_IMPORTED_MODULE_13__["default"],
  CarrierMetadata: _services_carrier_metadata_service__WEBPACK_IMPORTED_MODULE_14__["default"],
  CarrierType: _services_carrier_type_service__WEBPACK_IMPORTED_MODULE_15__["default"],
  CustomsInfo: _services_customs_info_service__WEBPACK_IMPORTED_MODULE_16__["default"],
  CustomsItem: _services_customs_item_service__WEBPACK_IMPORTED_MODULE_17__["default"],
  EndShipper: _services_end_shipper_service__WEBPACK_IMPORTED_MODULE_18__["default"],
  Event: _services_event_service__WEBPACK_IMPORTED_MODULE_19__["default"],
  Insurance: _services_insurance_service__WEBPACK_IMPORTED_MODULE_20__["default"],
  Order: _services_order_service__WEBPACK_IMPORTED_MODULE_21__["default"],
  Parcel: _services_parcel_service__WEBPACK_IMPORTED_MODULE_22__["default"],
  Pickup: _services_pickup_service__WEBPACK_IMPORTED_MODULE_23__["default"],
  Rate: _services_rate_service__WEBPACK_IMPORTED_MODULE_24__["default"],
  ReferralCustomer: _services_referral_customer_service__WEBPACK_IMPORTED_MODULE_25__["default"],
  Refund: _services_refund_service__WEBPACK_IMPORTED_MODULE_26__["default"],
  Report: _services_report_service__WEBPACK_IMPORTED_MODULE_27__["default"],
  ScanForm: _services_scan_form_service__WEBPACK_IMPORTED_MODULE_28__["default"],
  Shipment: _services_shipment_service__WEBPACK_IMPORTED_MODULE_29__["default"],
  Tracker: _services_tracker_service__WEBPACK_IMPORTED_MODULE_30__["default"],
  User: _services_user_service__WEBPACK_IMPORTED_MODULE_31__["default"],
  Webhook: _services_webhook_service__WEBPACK_IMPORTED_MODULE_32__["default"]
};

/**
 * The client used to access services of the EasyPost API.
 * This client is configured to use the latest production version of the EasyPost API.
 * @param {string} key The API key to use for API requests made by this client.
 * @param {Object} [options] Additional options to use for the underlying HTTP client (e.g. superagent, middleware, proxy configuration).
 */
class EasyPostClient {
  constructor(key, options = {}) {
    const {
      useProxy,
      timeout,
      baseUrl,
      superagentMiddleware,
      requestMiddleware
    } = options;
    if (!key && !useProxy) {
      throw new _errors_general_missing_parameter_error__WEBPACK_IMPORTED_MODULE_6__["default"]({
        message: util.format(_constants__WEBPACK_IMPORTED_MODULE_4__["default"].MISSING_REQUIRED_PARAMETER, 'API Key')
      });
    }
    this.key = key;
    this.timeout = timeout || DEFAULT_TIMEOUT;
    this.baseUrl = baseUrl || DEFAULT_BASE_URL;
    this.agent = (superagent__WEBPACK_IMPORTED_MODULE_1___default());
    this.requestMiddleware = requestMiddleware;
    this.requestHooks = [];
    this.responseHooks = [];
    this.Utils = new _utils_util__WEBPACK_IMPORTED_MODULE_33__["default"]();
    if (superagentMiddleware) {
      this.agent = superagentMiddleware(this.agent);
    }
    this._attachServices(SERVICES);
  }

  /**
   * Add a request hook function.
   * @param {(config: object) => void} hook
   */
  addRequestHook(hook) {
    this.requestHooks = [...this.requestHooks, hook];
  }
  /**
   * Remove a request hook function.
   * @param {(config: object) => void} hook
   */
  removeRequestHook(hook) {
    this.requestHooks = this.requestHooks.filter(h => h !== hook);
  }
  /**
   * Clear all request hooks.
   */
  clearRequestHooks() {
    this.requestHooks = [];
  }

  /**
   * Add a response hook function.
   * @param {(config: object) => void} hook
   */
  addResponseHook(hook) {
    this.responseHooks = [...this.responseHooks, hook];
  }
  /**
   * Remove a response hook function.
   * @param {(config: object) => void} hook
   */
  removeResponseHook(hook) {
    this.responseHooks = this.responseHooks.filter(h => h !== hook);
  }
  /**
   * Clear all response hooks.
   */
  clearResponseHooks() {
    this.responseHooks = [];
  }

  /**
   * Create a copy of an {@link EasyPostClient} with overridden options.
   * @param {EasyPostClient} client The `EasyPostClient` instance to clone.
   * @param {Object} [options] The options to override.
   * @returns {EasyPostClient} A new `EasyPostClient` instance.
   */
  static copyClient(client, options = {}) {
    const {
      apiKey,
      useProxy,
      timeout,
      baseUrl,
      superagentMiddleware,
      requestMiddleware
    } = options;
    const agent = superagentMiddleware ? superagentMiddleware(client.agent) : client.agent;
    return new EasyPostClient(apiKey || client.key, {
      useProxy: useProxy || client.useProxy,
      timeout: timeout || client.timeout,
      baseUrl: baseUrl || client.baseUrl,
      agent,
      requestMiddleware: requestMiddleware || client.requestMiddleware
    });
  }

  /**
   * Build request headers to be sent with each EasyPost API request, combined (or overridden) by any additional headers
   * @param {Object} [additionalHeaders] Additional headers to combine or override with the default headers.
   * @returns {Object} The headers to use for the request.
   */
  static _buildHeaders(additionalHeaders = {}) {
    return {
      ...DEFAULT_HEADERS,
      ...additionalHeaders
    };
  }

  /**
   * Attach services to an {@link EasyPostClient} instance.
   * @param {Map} services - A map of {@link BaseService}-based service classes to construct and attach to the client.
   */
  _attachServices(services) {
    Object.keys(services).forEach(s => {
      this[s] = services[s](this);
    });
  }

  /**
   * If the path passed in is a full URI, use it; otherwise, prepend the base url from the api.
   * @param {string} path - The path to build.
   * @returns {string} The full path to use for the HTTP request.
   */
  _buildPath(path = '') {
    if (path.indexOf('http') === 0) {
      return path;
    }
    let completePath = this.baseUrl + path;
    completePath = path.includes('beta') ? completePath.replace('v2', '') : completePath;
    return completePath;
  }

  /**
   * Create a value to be passed to the responseHooks, based on the requestHooks
   * value and the response.
   * @param {Object} baseHooksValue - the value being passed the requestHooks
   * @param {Object} response - the response from the superagent request
   * @returns {Object} - the value to be passed to the responseHooks
   */
  _createResponseHooksValue(baseHooksValue, response) {
    return {
      ...baseHooksValue,
      httpStatus: response.status,
      responseBody: response.body,
      headers: response.headers,
      responseTimestamp: Date.now()
    };
  }

  /**
   * Make an HTTP request.
   * @param {string} [path] - The partial path to append to the base url for the request.
   * @param {string} [method] - The HTTP method to use for the request, defaults to GET.
   * @param {Object} [params] - The parameters to send with the request.
   * @param {Object} [headers] - Additional headers to send with the request.
   * @returns {*} The response from the HTTP request.
   * @throws {ApiError} If the request fails.
   */
  async _request(path = '', method = METHODS.GET, params = {}, headers = {}) {
    const urlPath = this._buildPath(path);
    const requestHeaders = EasyPostClient._buildHeaders(headers);
    let request = this.agent[method](urlPath).set(requestHeaders);
    if (this.requestMiddleware) {
      request = this.requestMiddleware(request);
    }
    if (this.key) {
      request.auth(this.key);
    }

    // it would be ideal if this "full url with params" could be gotten from superagent directly,
    // but it doesn't seem to be possible
    const url = new URL(urlPath);
    if (params !== undefined) {
      if (method === METHODS.GET || method === METHODS.DELETE) {
        request.query(params);
        Object.entries(params).forEach(([key, value]) => {
          url.searchParams.append(key, value);
        });
      } else {
        request.send(params);
      }
    }
    const baseHooksValue = {
      method,
      path: url.toString(),
      requestBody: request._data,
      headers: requestHeaders,
      requestTimestamp: Date.now(),
      requestUUID: (0,uuid__WEBPACK_IMPORTED_MODULE_2__.v4)()
    };
    this.requestHooks.forEach(fn => fn(baseHooksValue));
    try {
      const response = await request;
      if (this.responseHooks.length > 0) {
        const responseHooksValue = this._createResponseHooksValue(baseHooksValue, response);
        this.responseHooks.forEach(fn => fn(responseHooksValue));
      }
      return response;
    } catch (error) {
      if (error.response && error.response.body) {
        const responseHooksValue = this._createResponseHooksValue(baseHooksValue, error.response);
        this.responseHooks.forEach(fn => fn(responseHooksValue));
        throw _errors_error_handler__WEBPACK_IMPORTED_MODULE_5__["default"].handleApiError(error.response);
      } else {
        throw error;
      }
    }
  }

  /**
   * Make a GET HTTP request.
   * @param {string} path - The partial path to append to the base url for the request.
   * @param {Object} [params] - The parameters to send with the request.
   * @param {Object} [headers] - Additional headers to send with the request.
   * @returns {*} The response from the HTTP request.
   */
  _get(path, params = {}, headers = {}) {
    return this._request(path, METHODS.GET, params, headers);
  }

  /**
   * Make a POST HTTP request.
   * @param {string} path - The partial path to append to the base url for the request.
   * @param {Object} [params] - The parameters to send with the request.
   * @param {Object} [headers] - Additional headers to send with the request.
   * @returns {*} The response from the HTTP request.
   */
  _post(path, params = {}, headers = {}) {
    return this._request(path, METHODS.POST, params, headers);
  }

  /**
   * Make a PUT HTTP request.
   * @param {string} path - The partial path to append to the base url for the request.
   * @param {Object} [params] - The parameters to send with the request.
   * @param {Object} [headers] - Additional headers to send with the request.
   * @returns {*} The response from the HTTP request.
   */
  _put(path, params = {}, headers = {}) {
    return this._request(path, METHODS.PUT, params, headers);
  }

  /**
   * Make a PATCH HTTP request.
   * @param {string} path - The partial path to append to the base url for the request.
   * @param {Object} [params] - The parameters to send with the request.
   * @param {Object} [headers] - Additional headers to send with the request.
   * @returns {*} The response from the HTTP request.
   */
  _patch(path, params = {}, headers = {}) {
    return this._request(path, METHODS.PATCH, params, headers);
  }

  /**
   * Make a DELETE HTTP request.
   * @param {string} path - The partial path to append to the base url for the request.
   * @param {Object} [params] - The parameters to send with the request.
   * @param {Object} [headers] - Additional headers to send with the request.
   * @returns {*} The response from the HTTP request.
   */
  _delete(path, params = {}, headers = {}) {
    return this._request(path, METHODS.DELETE, params, headers);
  }
}

/***/ }),

/***/ "./errors/api/api_error.js":
/*!*********************************!*\
  !*** ./errors/api/api_error.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ApiError)
/* harmony export */ });
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");


/**
 * The ApiError class is used to represent errors that occurred while communicating with the EasyPost API.
 * This class should not be instantiated directly.
 * @internal
 * @abstract
 * @extends EasyPostError
 * @property {string} [message] - The message to be displayed when the error is logged.
 * @property {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @property {number} [statusCode] - The HTTP status code returned by the HTTP request to the EasyPost API.
 * @property {EasyPostError[]} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class ApiError extends _easypost_error__WEBPACK_IMPORTED_MODULE_0__["default"] {
  constructor({
    message,
    code,
    statusCode,
    errors
  } = {}) {
    super({
      message
    });
    this.code = code;
    this.errors = errors;
    this.message = message;
    this.statusCode = statusCode;
  }
}

/***/ }),

/***/ "./errors/api/bad_request_error.js":
/*!*****************************************!*\
  !*** ./errors/api/bad_request_error.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ BadRequestError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The BadRequestError class is used to represent a 400 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class BadRequestError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/external_api_error.js":
/*!******************************************!*\
  !*** ./errors/api/external_api_error.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ExternalApiError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The ExternalApiError class is used to represent errors that occurred while communicating with an external API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 */
class ExternalApiError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/forbidden_error.js":
/*!***************************************!*\
  !*** ./errors/api/forbidden_error.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ForbiddenError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The ForbiddenError class is used to represent a 403 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class ForbiddenError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/gateway_timeout_error.js":
/*!*********************************************!*\
  !*** ./errors/api/gateway_timeout_error.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ GatewayTimeoutError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The GatewayTimeoutError class is used to represent a 504 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class GatewayTimeoutError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/internal_server_error.js":
/*!*********************************************!*\
  !*** ./errors/api/internal_server_error.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ InternalServerError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The InternalServerError class is used to represent a 500 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class InternalServerError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/invalid_request_error.js":
/*!*********************************************!*\
  !*** ./errors/api/invalid_request_error.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ InvalidRequestError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The InvalidRequestError class is used to represent a 422 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class InvalidRequestError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/method_not_allowed_error.js":
/*!************************************************!*\
  !*** ./errors/api/method_not_allowed_error.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ MethodNotAllowedError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The MethodNotAllowedError class is used to represent a 405 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class MethodNotAllowedError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/not_found_error.js":
/*!***************************************!*\
  !*** ./errors/api/not_found_error.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ NotFoundError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The NotFoundError class is used to represent a 404 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class NotFoundError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/payment_error.js":
/*!*************************************!*\
  !*** ./errors/api/payment_error.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ PaymentError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The PaymentError class is used to represent a 402 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class PaymentError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/rate_limit_error.js":
/*!****************************************!*\
  !*** ./errors/api/rate_limit_error.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ RateLimitError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The RateLimitError class is used to represent a 429 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class RateLimitError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/redirect_error.js":
/*!**************************************!*\
  !*** ./errors/api/redirect_error.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ RedirectError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The RedirectError class is used to represent a 3xx error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class RedirectError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/service_unavailable_error.js":
/*!*************************************************!*\
  !*** ./errors/api/service_unavailable_error.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ServiceUnavailableError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The ServiceUnavailableError class is used to represent a 503 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class ServiceUnavailableError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/timeout_error.js":
/*!*************************************!*\
  !*** ./errors/api/timeout_error.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ TimeoutError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The TimeoutError class is used to represent a 408 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class TimeoutError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/unauthorized_error.js":
/*!******************************************!*\
  !*** ./errors/api/unauthorized_error.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ UnauthorizedError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The UnauthorizedError class is used to represent a 401 error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class UnauthorizedError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/api/unknown_api_error.js":
/*!*****************************************!*\
  !*** ./errors/api/unknown_api_error.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ UnknownApiError)
/* harmony export */ });
/* harmony import */ var _api_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api_error */ "./errors/api/api_error.js");


/**
 * The UnknownApiError class is used to represent a generic, unexpected error that occurred while communicating with the EasyPost API.
 * @sealed
 * @extends ApiError
 * @param {string} [message] - The message to be displayed when the error is logged.
 * @param {number} [statusCode] - The HTTP status code returned by the HTTP request.
 * @param {string} [code] - The EasyPost-related error code returned by the EasyPost API.
 * @param {Array} [errors] - An array of sub-errors returned by the EasyPost API.
 */
class UnknownApiError extends _api_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/easypost_error.js":
/*!**********************************!*\
  !*** ./errors/easypost_error.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ EasyPostError)
/* harmony export */ });
/**
 * The EasyPostError class is the base class for all errors that occur in the EasyPost Node.js client library.
 * This class should not be instantiated directly.
 * @internal
 * @abstract
 * @extends Error
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class EasyPostError extends Error {
  constructor({
    message
  } = {}) {
    super(message);
  }
}

/***/ }),

/***/ "./errors/error_handler.js":
/*!*********************************!*\
  !*** ./errors/error_handler.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ErrorHandler)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _api_bad_request_error__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./api/bad_request_error */ "./errors/api/bad_request_error.js");
/* harmony import */ var _api_forbidden_error__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./api/forbidden_error */ "./errors/api/forbidden_error.js");
/* harmony import */ var _api_gateway_timeout_error__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./api/gateway_timeout_error */ "./errors/api/gateway_timeout_error.js");
/* harmony import */ var _api_internal_server_error__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./api/internal_server_error */ "./errors/api/internal_server_error.js");
/* harmony import */ var _api_invalid_request_error__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./api/invalid_request_error */ "./errors/api/invalid_request_error.js");
/* harmony import */ var _api_method_not_allowed_error__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./api/method_not_allowed_error */ "./errors/api/method_not_allowed_error.js");
/* harmony import */ var _api_not_found_error__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./api/not_found_error */ "./errors/api/not_found_error.js");
/* harmony import */ var _api_payment_error__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./api/payment_error */ "./errors/api/payment_error.js");
/* harmony import */ var _api_rate_limit_error__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./api/rate_limit_error */ "./errors/api/rate_limit_error.js");
/* harmony import */ var _api_redirect_error__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./api/redirect_error */ "./errors/api/redirect_error.js");
/* harmony import */ var _api_service_unavailable_error__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./api/service_unavailable_error */ "./errors/api/service_unavailable_error.js");
/* harmony import */ var _api_timeout_error__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./api/timeout_error */ "./errors/api/timeout_error.js");
/* harmony import */ var _api_unauthorized_error__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./api/unauthorized_error */ "./errors/api/unauthorized_error.js");
/* harmony import */ var _api_unknown_api_error__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./api/unknown_api_error */ "./errors/api/unknown_api_error.js");
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./easypost_error */ "./errors/easypost_error.js");
















class ErrorHandler {
  /**
   * Recursively traverses a JSON object or array and extracts error messages
   * as strings. Adds the extracted messages to the specified messagesList array.
   *
   * @param {object|array|string} errorMessage - The JSON object or array to traverse.
   * @param {array} messagesList - The array to which extracted error messages will be added.
   */
  static traverseJsonElement(errorMessage, messagesList) {
    if (errorMessage instanceof Object) {
      for (const value of Object.values(errorMessage)) {
        this.traverseJsonElement(value, messagesList);
      }
    } else if (errorMessage instanceof Array) {
      for (const value of errorMessage) {
        this.traverseJsonElement(value, messagesList);
      }
    } else {
      messagesList.push(errorMessage.toString());
    }
  }
  /**
   * Calculate and generate the appropriate {@link ApiError} based on a received HTTP response error.
   * @param {*} error - The errored HTTP response.
   * @returns {ApiError} The `ApiError`-based error corresponding to the HTTP status code.
   */
  static handleApiError(error) {
    const {
      statusCode
    } = error;
    const {
      code,
      message,
      errors
    } = error.body.error;
    const errorParams = {
      message,
      code,
      statusCode,
      errors
    };
    try {
      const messages = [];
      this.traverseJsonElement(errorParams.message, messages);
      errorParams.message = messages.join(', ');
    } catch (e) {
      const errorParams = {
        message: _constants__WEBPACK_IMPORTED_MODULE_0__["default"].ERROR_DESERIALIZATION,
        code: 'ERROR_DESERIALIZATION_ERROR'
      };
      return new _easypost_error__WEBPACK_IMPORTED_MODULE_15__["default"](errorParams);
    }
    if (statusCode >= 300 && statusCode < 400) {
      return new _api_redirect_error__WEBPACK_IMPORTED_MODULE_10__["default"](errorParams);
    }
    switch (statusCode) {
      case 400:
        return new _api_bad_request_error__WEBPACK_IMPORTED_MODULE_1__["default"](errorParams);
      case 401:
        return new _api_unauthorized_error__WEBPACK_IMPORTED_MODULE_13__["default"](errorParams);
      case 402:
        return new _api_payment_error__WEBPACK_IMPORTED_MODULE_8__["default"](errorParams);
      case 403:
        return new _api_forbidden_error__WEBPACK_IMPORTED_MODULE_2__["default"](errorParams);
      case 404:
        return new _api_not_found_error__WEBPACK_IMPORTED_MODULE_7__["default"](errorParams);
      case 405:
        return new _api_method_not_allowed_error__WEBPACK_IMPORTED_MODULE_6__["default"](errorParams);
      case 408:
        return new _api_timeout_error__WEBPACK_IMPORTED_MODULE_12__["default"](errorParams);
      case 422:
        return new _api_invalid_request_error__WEBPACK_IMPORTED_MODULE_5__["default"](errorParams);
      case 429:
        return new _api_rate_limit_error__WEBPACK_IMPORTED_MODULE_9__["default"](errorParams);
      case 500:
        return new _api_internal_server_error__WEBPACK_IMPORTED_MODULE_4__["default"](errorParams);
      case 503:
        return new _api_service_unavailable_error__WEBPACK_IMPORTED_MODULE_11__["default"](errorParams);
      case 504:
        return new _api_gateway_timeout_error__WEBPACK_IMPORTED_MODULE_3__["default"](errorParams);
      default:
        return new _api_unknown_api_error__WEBPACK_IMPORTED_MODULE_14__["default"](errorParams);
    }
  }
}

/***/ }),

/***/ "./errors/general/end_of_pagination_error.js":
/*!***************************************************!*\
  !*** ./errors/general/end_of_pagination_error.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ EndOfPaginationError)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../constants */ "./constants.js");
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");



/**
 * The EndOfPaginationError class is used to represent an error that no more page can be retrieved
 * @sealed
 * @extends EasyPostError
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class EndOfPaginationError extends _easypost_error__WEBPACK_IMPORTED_MODULE_1__["default"] {
  constructor() {
    super({
      message: _constants__WEBPACK_IMPORTED_MODULE_0__["default"].END_OF_PAGINATION
    });
  }
}

/***/ }),

/***/ "./errors/general/filtering_error.js":
/*!*******************************************!*\
  !*** ./errors/general/filtering_error.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ FilteringError)
/* harmony export */ });
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");


/**
 * The FilteringError class is used to represent an error that occurred while filtering a list (e.g. a list of rates).
 * @sealed
 * @extends EasyPostError
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class FilteringError extends _easypost_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/general/invalid_object_error.js":
/*!************************************************!*\
  !*** ./errors/general/invalid_object_error.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ InvalidObjectError)
/* harmony export */ });
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");


/**
 * The InvalidObjectError class is used to represent an error due to an invalid object (e.g. missing an expected property).
 * @sealed
 * @extends EasyPostError
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class InvalidObjectError extends _easypost_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/general/invalid_parameter_error.js":
/*!***************************************************!*\
  !*** ./errors/general/invalid_parameter_error.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ InvalidParameterError)
/* harmony export */ });
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");


/**
 * The InvalidParameterError class is used to represent an error due to an invalid function parameter.
 * @sealed
 * @extends EasyPostError
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class InvalidParameterError extends _easypost_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/general/missing_parameter_error.js":
/*!***************************************************!*\
  !*** ./errors/general/missing_parameter_error.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ MissingParameterError)
/* harmony export */ });
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");


/**
 * The MissingParameterError class is used to represent an error due to a missing expected function parameter.
 * @sealed
 * @extends EasyPostError
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class MissingParameterError extends _easypost_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./errors/general/signature_verification_error.js":
/*!********************************************************!*\
  !*** ./errors/general/signature_verification_error.js ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ SignatureVerificationError)
/* harmony export */ });
/* harmony import */ var _easypost_error__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../easypost_error */ "./errors/easypost_error.js");


/**
 * The SignatureVerificationError class is used to represent an error due to a failed signature verification (e.g. a webhook HMAC signature).
 * @sealed
 * @extends EasyPostError
 * @param {string} [message] - The message to be displayed when the error is logged.
 */
class SignatureVerificationError extends _easypost_error__WEBPACK_IMPORTED_MODULE_0__["default"] {}

/***/ }),

/***/ "./models/address.js":
/*!***************************!*\
  !*** ./models/address.js ***!
  \***************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Address)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * An {@link https://www.easypost.com/docs/api/node#addresses Address} represents people, places, and organizations in a number of contexts.
 * @public
 * @extends EasyPostObject
 */
class Address extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Address, "street1", void 0);
_defineProperty(Address, "street2", void 0);
_defineProperty(Address, "city", void 0);
_defineProperty(Address, "state", void 0);
_defineProperty(Address, "zip", void 0);
_defineProperty(Address, "country", void 0);
_defineProperty(Address, "residential", void 0);
_defineProperty(Address, "carrier_facility", void 0);
_defineProperty(Address, "name", void 0);
_defineProperty(Address, "company", void 0);
_defineProperty(Address, "phone", void 0);
_defineProperty(Address, "email", void 0);
_defineProperty(Address, "federal_tax_id", void 0);
_defineProperty(Address, "state_tax_id", void 0);
_defineProperty(Address, "verifications", void 0);

/***/ }),

/***/ "./models/api_key.js":
/*!***************************!*\
  !*** ./models/api_key.js ***!
  \***************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ApiKey)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * An {@link https://www.easypost.com/docs/api/node#api-keys ApiKey} represents an authentication token that can be used to make requests to the EasyPost API.
 * @public
 * @extends EasyPostObject
 */
class ApiKey extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(ApiKey, "active", void 0);
_defineProperty(ApiKey, "key", void 0);

/***/ }),

/***/ "./models/batch.js":
/*!*************************!*\
  !*** ./models/batch.js ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Batch)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#batches Batch} represents a collection of {@link Shipment shipments} that can be processed together.
 * @public
 * @extends EasyPostObject
 */
class Batch extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Batch, "label_url", void 0);
_defineProperty(Batch, "num_shipments", void 0);
_defineProperty(Batch, "pickup", void 0);
_defineProperty(Batch, "reference", void 0);
_defineProperty(Batch, "scan_form", void 0);
_defineProperty(Batch, "shipments", void 0);
_defineProperty(Batch, "state", void 0);
_defineProperty(Batch, "status", void 0);

/***/ }),

/***/ "./models/brand.js":
/*!*************************!*\
  !*** ./models/brand.js ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Brand)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#brand Brand} represents custom branding for an EasyPost user's public-facing tracking details page.
 * @public
 * @extends EasyPostObject
 */
class Brand extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Brand, "ad_href", void 0);
_defineProperty(Brand, "ad", void 0);
_defineProperty(Brand, "background_color", void 0);
_defineProperty(Brand, "color", void 0);
_defineProperty(Brand, "logo_href", void 0);
_defineProperty(Brand, "logo", void 0);
_defineProperty(Brand, "name", void 0);
_defineProperty(Brand, "theme", void 0);
_defineProperty(Brand, "user_id", void 0);

/***/ }),

/***/ "./models/carrier_account.js":
/*!***********************************!*\
  !*** ./models/carrier_account.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ CarrierAccount)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#carrier-accounts CarrierAccount} represents details about a specific enabled carrier, including credentials and other information.
 * @public
 * @extends EasyPostObject
 */
class CarrierAccount extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(CarrierAccount, "billing_type", void 0);
_defineProperty(CarrierAccount, "clone", void 0);
_defineProperty(CarrierAccount, "credentials", void 0);
_defineProperty(CarrierAccount, "description", void 0);
_defineProperty(CarrierAccount, "fields", void 0);
_defineProperty(CarrierAccount, "readable", void 0);
_defineProperty(CarrierAccount, "reference", void 0);
_defineProperty(CarrierAccount, "test_credentials", void 0);

/***/ }),

/***/ "./models/carrier_type.js":
/*!********************************!*\
  !*** ./models/carrier_type.js ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ CarrierType)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#carrier-types CarrierType} represents the valid fields for a {@link CarrierAccount carrier account}.
 * @public
 * @extends EasyPostObject
 */
class CarrierType extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(CarrierType, "fields", void 0);
_defineProperty(CarrierType, "type", void 0);

/***/ }),

/***/ "./models/customs_info.js":
/*!********************************!*\
  !*** ./models/customs_info.js ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ CustomsInfo)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#customs-infos CustomsInfo} represents a collection of {@link CustomsItem CustomsItems} and associated information for generating international shipping customs forms.
 * @public
 * @extends EasyPostObject
 */
class CustomsInfo extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(CustomsInfo, "content_explanation", void 0);
_defineProperty(CustomsInfo, "contents_type", void 0);
_defineProperty(CustomsInfo, "customs_certify", void 0);
_defineProperty(CustomsInfo, "customs_items", void 0);
_defineProperty(CustomsInfo, "customs_signer", void 0);
_defineProperty(CustomsInfo, "declaration", void 0);
_defineProperty(CustomsInfo, "eel_pfc", void 0);
_defineProperty(CustomsInfo, "non_delivery_option", void 0);
_defineProperty(CustomsInfo, "restriction_comments", void 0);
_defineProperty(CustomsInfo, "restriction_type", void 0);

/***/ }),

/***/ "./models/customs_item.js":
/*!********************************!*\
  !*** ./models/customs_item.js ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ CustomsItem)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#customs-item CustomsItem} represents a single item being shipped internationally.
 * @public
 * @extends EasyPostObject
 */
class CustomsItem extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(CustomsItem, "code", void 0);
_defineProperty(CustomsItem, "currency", void 0);
_defineProperty(CustomsItem, "description", void 0);
_defineProperty(CustomsItem, "hs_tariff_number", void 0);
_defineProperty(CustomsItem, "origin_country", void 0);
_defineProperty(CustomsItem, "quantity", void 0);
_defineProperty(CustomsItem, "value", void 0);
_defineProperty(CustomsItem, "weight", void 0);

/***/ }),

/***/ "./models/easypost_object.js":
/*!***********************************!*\
  !*** ./models/easypost_object.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ EasyPostObject)
/* harmony export */ });
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * An EasyPostObject is the base class for all EasyPost API resources.
 * @internal
 * @abstract
 */
class EasyPostObject {}
_defineProperty(EasyPostObject, "id", void 0);
_defineProperty(EasyPostObject, "object", void 0);
_defineProperty(EasyPostObject, "mode", void 0);
_defineProperty(EasyPostObject, "created_at", void 0);
_defineProperty(EasyPostObject, "updated_at", void 0);
_defineProperty(EasyPostObject, "_params", void 0);

/***/ }),

/***/ "./models/end_shipper.js":
/*!*******************************!*\
  !*** ./models/end_shipper.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ EndShipper)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * An {@link https://www.easypost.com/docs/api/node#endshipper EndShipper} represents a person or business entity that is authorized to purchase postage on behalf of another person and is ultimately responsible for the shipment.
 * @public
 * @extends EasyPostObject
 */
class EndShipper extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(EndShipper, "street1", void 0);
_defineProperty(EndShipper, "street2", void 0);
_defineProperty(EndShipper, "city", void 0);
_defineProperty(EndShipper, "state", void 0);
_defineProperty(EndShipper, "zip", void 0);
_defineProperty(EndShipper, "country", void 0);
_defineProperty(EndShipper, "name", void 0);
_defineProperty(EndShipper, "company", void 0);
_defineProperty(EndShipper, "phone", void 0);
_defineProperty(EndShipper, "email", void 0);

/***/ }),

/***/ "./models/event.js":
/*!*************************!*\
  !*** ./models/event.js ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Event)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * An {@link https://www.easypost.com/docs/api/node#events Event} represents a change in state for elements such as {@link Shipment shipments} and {@link Tracker trackers}, that triggers a {@link Webhook webhook}.
 * @public
 * @extends EasyPostObject
 */
class Event extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Event, "completed_urls", void 0);
_defineProperty(Event, "description", void 0);
_defineProperty(Event, "pending_urls", void 0);
_defineProperty(Event, "previous_attributes", void 0);
_defineProperty(Event, "result", void 0);
_defineProperty(Event, "status", void 0);

/***/ }),

/***/ "./models/form.js":
/*!************************!*\
  !*** ./models/form.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Form)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#forms Form} represents a printable form for a {@link Shipment shipment}, such as a return packing slip, QR code or international shipping form.
 * @public
 * @extends EasyPostObject
 */
class Form extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Form, "form_type", void 0);
_defineProperty(Form, "form_url", void 0);
_defineProperty(Form, "submitted_electronically", void 0);

/***/ }),

/***/ "./models/insurance.js":
/*!*****************************!*\
  !*** ./models/insurance.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Insurance)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * An {@link https://www.easypost.com/docs/api/node#api-keys Insurance} object represents insurance for a {@link Shipment shipment}.
 * @public
 * @extends EasyPostObject
 */
class Insurance extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Insurance, "amount", void 0);
_defineProperty(Insurance, "fee", void 0);
_defineProperty(Insurance, "from_address", void 0);
_defineProperty(Insurance, "messages", void 0);
_defineProperty(Insurance, "provider_id", void 0);
_defineProperty(Insurance, "provider", void 0);
_defineProperty(Insurance, "reference", void 0);
_defineProperty(Insurance, "shipment_id", void 0);
_defineProperty(Insurance, "status", void 0);
_defineProperty(Insurance, "to_address", void 0);
_defineProperty(Insurance, "tracking_code", void 0);
_defineProperty(Insurance, "tracker", void 0);

/***/ }),

/***/ "./models/order.js":
/*!*************************!*\
  !*** ./models/order.js ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Order)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }



/**
 * An {@link https://www.easypost.com/docs/api/node#orders Order} represents a collection of packages, intended only for multi-parcel shipments.
 * @public
 * @extends EasyPostObject
 */
class Order extends _easypost_object__WEBPACK_IMPORTED_MODULE_1__["default"] {
  /**
   * Get the lowest rate for this {@link Order}.
   * @public
   * @param {string[]} [carriers] - List of allowed carriers to filter by
   * @param {string[]} [services] - List of allowed services to filter by
   * @returns {Rate} - The lowest rate
   * @throws {FilteringError} - If no applicable rates are found
   */
  lowestRate(carriers, services) {
    const rates = this.rates || [];
    return _constants__WEBPACK_IMPORTED_MODULE_0__["default"].Utils.getLowestRate(rates, carriers, services);
  }
}
_defineProperty(Order, "buyer_address", void 0);
_defineProperty(Order, "from_address", void 0);
_defineProperty(Order, "is_return", void 0);
_defineProperty(Order, "messages", void 0);
_defineProperty(Order, "rates", void 0);
_defineProperty(Order, "reference", void 0);
_defineProperty(Order, "return_address", void 0);
_defineProperty(Order, "shipments", void 0);
_defineProperty(Order, "to_address", void 0);

/***/ }),

/***/ "./models/parcel.js":
/*!**************************!*\
  !*** ./models/parcel.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Parcel)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#parcels Parcel} represents a physical container being shipped, such as a box or envelope, with corresponding dimensions and weight.
 * @public
 * @extends EasyPostObject
 */
class Parcel extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Parcel, "height", void 0);
_defineProperty(Parcel, "length", void 0);
_defineProperty(Parcel, "predefined_package", void 0);
_defineProperty(Parcel, "weight", void 0);
_defineProperty(Parcel, "width", void 0);

/***/ }),

/***/ "./models/payload.js":
/*!***************************!*\
  !*** ./models/payload.js ***!
  \***************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Payload)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#payloads Payload} represents an attempt by EasyPost to send an {@link Event event} to a {@link Webhook webhook}.
 * @public
 * @extends EasyPostObject
 */
class Payload extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Payload, "response_body", void 0);

/***/ }),

/***/ "./models/pickup.js":
/*!**************************!*\
  !*** ./models/pickup.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Pickup)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }



/**
 * A {@link https://www.easypost.com/docs/api/node#pickups Pickup} represents a scheduled carrier pickup of packages from an {@link https://www.easypost.com/docs/api/node#addresses Address}.
 * @public
 * @extends EasyPostObject
 */
class Pickup extends _easypost_object__WEBPACK_IMPORTED_MODULE_1__["default"] {
  /**
   * Get the lowest rate for this {@link Pickup}.
   * @public
   * @param {string[]} [carriers] - List of allowed carriers to filter by
   * @param {string[]} [services] - List of allowed services to filter by
   * @returns {Rate} - The lowest rate
   * @throws {FilteringError} - If no applicable rates are found
   */
  lowestRate(carriers, services) {
    const rates = this.pickup_rates || [];
    return _constants__WEBPACK_IMPORTED_MODULE_0__["default"].Utils.getLowestRate(rates, carriers, services);
  }
}
_defineProperty(Pickup, "address", void 0);
_defineProperty(Pickup, "carrier_accounts", void 0);
_defineProperty(Pickup, "confirmation", void 0);
_defineProperty(Pickup, "instructions", void 0);
_defineProperty(Pickup, "is_account_address", void 0);
_defineProperty(Pickup, "max_datetime", void 0);
_defineProperty(Pickup, "messages", void 0);
_defineProperty(Pickup, "min_datetime", void 0);
_defineProperty(Pickup, "pickup_rates", void 0);
_defineProperty(Pickup, "reference", void 0);
_defineProperty(Pickup, "shipment", void 0);
_defineProperty(Pickup, "status", void 0);

/***/ }),

/***/ "./models/pickup_rate.js":
/*!*******************************!*\
  !*** ./models/pickup_rate.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ PickupRate)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link PickupRate} represents a {@link Rate rate} for a {@link Pickup pickup}.
 * @public
 * @extends EasyPostObject
 */
class PickupRate extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(PickupRate, "carrier", void 0);
_defineProperty(PickupRate, "currency", void 0);
_defineProperty(PickupRate, "pickup_id", void 0);
_defineProperty(PickupRate, "rate", void 0);
_defineProperty(PickupRate, "service", void 0);

/***/ }),

/***/ "./models/postage_label.js":
/*!*********************************!*\
  !*** ./models/postage_label.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ PostageLabel)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link PostageLabel} represents a physical label to affix to a {@link Parcel parcel} when shipping.
 * @public
 * @extends EasyPostObject
 */
class PostageLabel extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(PostageLabel, "label_date", void 0);
_defineProperty(PostageLabel, "label_epl2_url", void 0);
_defineProperty(PostageLabel, "label_file_type", void 0);
_defineProperty(PostageLabel, "label_pdf_url", void 0);
_defineProperty(PostageLabel, "label_resolution", void 0);
_defineProperty(PostageLabel, "label_size", void 0);
_defineProperty(PostageLabel, "label_type", void 0);
_defineProperty(PostageLabel, "label_url", void 0);
_defineProperty(PostageLabel, "label_zpl_url", void 0);

/***/ }),

/***/ "./models/rate.js":
/*!************************!*\
  !*** ./models/rate.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Rate)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#rates Rate} represents pricing information for shipping a specific {@link Parcel} with a specific carrier and service level.
 * @public
 * @extends EasyPostObject
 */
class Rate extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Rate, "billing_type", void 0);
_defineProperty(Rate, "carrier_account_id", void 0);
_defineProperty(Rate, "carrier", void 0);
_defineProperty(Rate, "currency", void 0);
_defineProperty(Rate, "delivery_date_guaranteed", void 0);
_defineProperty(Rate, "delivery_days", void 0);
_defineProperty(Rate, "list_currency", void 0);
_defineProperty(Rate, "list_rate", void 0);
_defineProperty(Rate, "rate", void 0);
_defineProperty(Rate, "retail_currency", void 0);
_defineProperty(Rate, "retail_rate", void 0);
_defineProperty(Rate, "service", void 0);
_defineProperty(Rate, "shipment_id", void 0);

/***/ }),

/***/ "./models/refund.js":
/*!**************************!*\
  !*** ./models/refund.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Refund)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#refunds Refund} represents a refunded {@link Shipment}.
 * @public
 * @extends EasyPostObject
 */
class Refund extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Refund, "carrier", void 0);
_defineProperty(Refund, "confirmation_number", void 0);
_defineProperty(Refund, "shipment_id", void 0);
_defineProperty(Refund, "status", void 0);
_defineProperty(Refund, "tracking_code", void 0);

/***/ }),

/***/ "./models/report.js":
/*!**************************!*\
  !*** ./models/report.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Report)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#reports Report} represents a CSV file containing a log of all objects within a specific time frame.
 * @public
 * @extends EasyPostObject
 */
class Report extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Report, "end_date", void 0);
_defineProperty(Report, "include_children", void 0);
_defineProperty(Report, "send_email", void 0);
_defineProperty(Report, "start_date", void 0);
_defineProperty(Report, "status", void 0);
_defineProperty(Report, "url_expires_at", void 0);
_defineProperty(Report, "url", void 0);

/***/ }),

/***/ "./models/scan_form.js":
/*!*****************************!*\
  !*** ./models/scan_form.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ ScanForm)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#scan-form ScanForm} represents a single document that can be scanned to mark all included tracking codes as "Accepted for Shipment" by the carrier.
 * @public
 * @extends EasyPostObject
 */
class ScanForm extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(ScanForm, "address", void 0);
_defineProperty(ScanForm, "batch_id", void 0);
_defineProperty(ScanForm, "form_file_type", void 0);
_defineProperty(ScanForm, "form_url", void 0);
_defineProperty(ScanForm, "message", void 0);
_defineProperty(ScanForm, "status", void 0);
_defineProperty(ScanForm, "tracking_codes", void 0);

/***/ }),

/***/ "./models/shipment.js":
/*!****************************!*\
  !*** ./models/shipment.js ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Shipment)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }



/**
 * A {@link https://www.easypost.com/docs/api/node#shipments Shipment} represents a physical {@link Parcel}, the origin and destination {@link Address Addresses}, and any associated {@link CustomsInfo}.
 * @public
 * @extends EasyPostObject
 */
class Shipment extends _easypost_object__WEBPACK_IMPORTED_MODULE_1__["default"] {
  /**
   * Get the lowest rate for this {@link Shipment}.
   * @public
   * @param {string[]} [carriers] - List of allowed carriers to filter by
   * @param {string[]} [services] - List of allowed services to filter by
   * @returns {Rate} - The lowest rate
   * @throws {FilteringError} - If no applicable rates are found
   */
  lowestRate(carriers, services) {
    const rates = this.rates || [];
    return _constants__WEBPACK_IMPORTED_MODULE_0__["default"].Utils.getLowestRate(rates, carriers, services);
  }
}
_defineProperty(Shipment, "batch_id", void 0);
_defineProperty(Shipment, "batch_message", void 0);
_defineProperty(Shipment, "batch_status", void 0);
_defineProperty(Shipment, "buyer_address", void 0);
_defineProperty(Shipment, "customs_info", void 0);
_defineProperty(Shipment, "fees", void 0);
_defineProperty(Shipment, "forms", void 0);
_defineProperty(Shipment, "from_address", void 0);
_defineProperty(Shipment, "insurance", void 0);
_defineProperty(Shipment, "is_return", void 0);
_defineProperty(Shipment, "messages", void 0);
_defineProperty(Shipment, "options", void 0);
_defineProperty(Shipment, "parcel", void 0);
_defineProperty(Shipment, "postage_label", void 0);
_defineProperty(Shipment, "rates", void 0);
_defineProperty(Shipment, "reference", void 0);
_defineProperty(Shipment, "refund_status", void 0);
_defineProperty(Shipment, "return_address", void 0);
_defineProperty(Shipment, "scan_form", void 0);
_defineProperty(Shipment, "selected_rate", void 0);
_defineProperty(Shipment, "status", void 0);
_defineProperty(Shipment, "to_address", void 0);
_defineProperty(Shipment, "tracker", void 0);
_defineProperty(Shipment, "tracking_code", void 0);
_defineProperty(Shipment, "usps_zone", void 0);

/***/ }),

/***/ "./models/tracker.js":
/*!***************************!*\
  !*** ./models/tracker.js ***!
  \***************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Tracker)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#trackers Tracker} represents the available tracking information for a package.
 * @public
 * @extends EasyPostObject
 */
class Tracker extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Tracker, "carrier_details", void 0);
_defineProperty(Tracker, "carrier", void 0);
_defineProperty(Tracker, "est_delivery_date", void 0);
_defineProperty(Tracker, "fees", void 0);
_defineProperty(Tracker, "public_url", void 0);
_defineProperty(Tracker, "shipment_id", void 0);
_defineProperty(Tracker, "signed_by", void 0);
_defineProperty(Tracker, "status", void 0);
_defineProperty(Tracker, "status_detail", void 0);
_defineProperty(Tracker, "tracking_code", void 0);
_defineProperty(Tracker, "tracking_details", void 0);
_defineProperty(Tracker, "weight", void 0);

/***/ }),

/***/ "./models/user.js":
/*!************************!*\
  !*** ./models/user.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ User)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#user ApiKey} represents an EasyPost account or child account.
 * @public
 * @extends EasyPostObject
 */
class User extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(User, "api_keys", void 0);
_defineProperty(User, "balance", void 0);
_defineProperty(User, "cc_fee_rate", void 0);
_defineProperty(User, "children", void 0);
_defineProperty(User, "email", void 0);
_defineProperty(User, "insurance_fee_minimum", void 0);
_defineProperty(User, "insurance_fee_rate", void 0);
_defineProperty(User, "name", void 0);
_defineProperty(User, "parent_id", void 0);
_defineProperty(User, "phone_number", void 0);
_defineProperty(User, "price_per_shipment", void 0);
_defineProperty(User, "recharge_amount", void 0);
_defineProperty(User, "secondary_recharge_amount", void 0);

/***/ }),

/***/ "./models/webhook.js":
/*!***************************!*\
  !*** ./models/webhook.js ***!
  \***************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Webhook)
/* harmony export */ });
/* harmony import */ var _easypost_object__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./easypost_object */ "./models/easypost_object.js");
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }


/**
 * A {@link https://www.easypost.com/docs/api/node#webhooks Webhook} represents a URL that will receive notifications when certain {@link Event} occur.
 * @public
 * @extends EasyPostObject
 */
class Webhook extends _easypost_object__WEBPACK_IMPORTED_MODULE_0__["default"] {}
_defineProperty(Webhook, "disabled_at", void 0);
_defineProperty(Webhook, "url", void 0);

/***/ }),

/***/ "./services/address_service.js":
/*!*************************************!*\
  !*** ./services/address_service.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The AddressService class provides methods for interacting with EasyPost {@link Address} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class AddressService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create an {@link Address address}.
   * See {@link https://www.easypost.com/docs/api/node#create-an-address EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the address to be created.
   * @returns {Address} - The created address.
   */
  static async create(params) {
    const url = 'addresses';
    const wrappedParams = {
      address: params
    };
    if (params.verify) {
      const clone = params;
      wrappedParams.verify = params.verify;
      delete clone.verify;
    }
    if (params.verify_strict) {
      const clone = params;
      wrappedParams.verify_strict = params.verify_strict;
      delete clone.verify_strict;
    }
    return this._create(url, wrappedParams);
  }

  /**
   * Create and verify an {@link Address address} in a single request.
   * See {@link https://www.easypost.com/docs/api/node#create-and-verify-addresses EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the address to be created.
   * @returns {Address} - The created and verified address.
   */
  static async createAndVerify(params) {
    const url = `addresses/create_and_verify`;
    const wrappedParams = {
      address: params
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body.address, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve all {@link Address addresses} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-addresses EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the list of addresses.
   * @returns {Object} - An object containing a list of {@link Address addresses} and pagination information.
   */
  static async all(params = {}) {
    const url = 'addresses';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Address collection.
   * @param {Object} addresses An object containing a list of {@link Address addresses} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(addresses, pageSize = null) {
    const url = 'addresses';
    return this._getNextPage(url, 'addresses', addresses, pageSize);
  }

  /**
   * Retrieve an {@link Address address} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-address EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the address to retrieve.
   * @returns {Address} - The retrieved address.
   */
  static async retrieve(id) {
    const url = `addresses/${id}`;
    return this._retrieve(url);
  }

  /**
   * Verify an {@link Address address} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#create-and-verify-addresses EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the address to verify.
   * @returns {Address} - The verified address.
   */
  static async verifyAddress(id) {
    try {
      const url = `addresses/${id}/verify`;
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body.address);
    } catch (e) {
      return Promise.reject(e);
    }
  }
});

/***/ }),

/***/ "./services/api_key_service.js":
/*!*************************************!*\
  !*** ./services/api_key_service.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _errors_general_filtering_error__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../errors/general/filtering_error */ "./errors/general/filtering_error.js");



const util = __webpack_require__(/*! util */ "util");
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The ApiKeyService class provides methods for interacting with EasyPost {@link ApiKey} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class ApiKeyService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Retrieve all {@link ApiKey API keys} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-api-key EasyPost API Documentation} for more information.
   * @returns {Object} - An object containing the API keys associated with the current authenticated user and its child users.
   */
  static async all(params = {}) {
    const url = 'api_keys';
    return this._all(url, params);
  }

  /**
   * Retrieve API Keys for a specified {@link User user}.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-api-key EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the user to retrieve keys for.
   * @returns {Array} - List of associated API Keys.
   * @throws {FilteringError} If user or API Keys are not found.
   */
  static async retrieveApiKeysForUser(id) {
    const url = `api_keys`;
    try {
      const response = await easypostClient._get(url);
      const user = this._convertToEasyPostObject(response.body);
      if (user.id == id) {
        return user.keys;
      }
      user.children.forEach(child => {
        if (child.id == id) {
          return child.keys;
        }
      });
    } catch (e) {
      return Promise.reject(e);
    }
    throw new _errors_general_filtering_error__WEBPACK_IMPORTED_MODULE_2__["default"]({
      message: util.format(_constants__WEBPACK_IMPORTED_MODULE_1__["default"].NO_OBJECT_FOUND, 'child')
    });
  }
});

/***/ }),

/***/ "./services/base_service.js":
/*!**********************************!*\
  !*** ./services/base_service.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _models_address__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../models/address */ "./models/address.js");
/* harmony import */ var _models_api_key__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../models/api_key */ "./models/api_key.js");
/* harmony import */ var _models_batch__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../models/batch */ "./models/batch.js");
/* harmony import */ var _models_brand__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models/brand */ "./models/brand.js");
/* harmony import */ var _models_carrier_account__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../models/carrier_account */ "./models/carrier_account.js");
/* harmony import */ var _models_carrier_type__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../models/carrier_type */ "./models/carrier_type.js");
/* harmony import */ var _models_customs_info__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../models/customs_info */ "./models/customs_info.js");
/* harmony import */ var _models_customs_item__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../models/customs_item */ "./models/customs_item.js");
/* harmony import */ var _models_easypost_object__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../models/easypost_object */ "./models/easypost_object.js");
/* harmony import */ var _models_end_shipper__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../models/end_shipper */ "./models/end_shipper.js");
/* harmony import */ var _models_event__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ../models/event */ "./models/event.js");
/* harmony import */ var _models_form__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ../models/form */ "./models/form.js");
/* harmony import */ var _models_insurance__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ../models/insurance */ "./models/insurance.js");
/* harmony import */ var _models_order__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ../models/order */ "./models/order.js");
/* harmony import */ var _models_parcel__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ../models/parcel */ "./models/parcel.js");
/* harmony import */ var _models_payload__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ../models/payload */ "./models/payload.js");
/* harmony import */ var _models_pickup__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ../models/pickup */ "./models/pickup.js");
/* harmony import */ var _models_pickup_rate__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ../models/pickup_rate */ "./models/pickup_rate.js");
/* harmony import */ var _models_postage_label__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ../models/postage_label */ "./models/postage_label.js");
/* harmony import */ var _models_rate__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ../models/rate */ "./models/rate.js");
/* harmony import */ var _models_refund__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ../models/refund */ "./models/refund.js");
/* harmony import */ var _models_report__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ../models/report */ "./models/report.js");
/* harmony import */ var _models_scan_form__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ../models/scan_form */ "./models/scan_form.js");
/* harmony import */ var _models_shipment__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ../models/shipment */ "./models/shipment.js");
/* harmony import */ var _models_tracker__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ../models/tracker */ "./models/tracker.js");
/* harmony import */ var _models_user__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ../models/user */ "./models/user.js");
/* harmony import */ var _models_webhook__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ../models/webhook */ "./models/webhook.js");
/* harmony import */ var _errors_general_end_of_pagination_error__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ../errors/general/end_of_pagination_error */ "./errors/general/end_of_pagination_error.js");





























/**
 * A map of EasyPost object ID prefixes to their associated class names.
 */
const EASYPOST_OBJECT_ID_PREFIX_TO_CLASS_NAME_MAP = {
  adr: _models_address__WEBPACK_IMPORTED_MODULE_0__["default"],
  ak: _models_api_key__WEBPACK_IMPORTED_MODULE_1__["default"],
  batch: _models_batch__WEBPACK_IMPORTED_MODULE_2__["default"],
  brd: _models_brand__WEBPACK_IMPORTED_MODULE_3__["default"],
  ca: _models_carrier_account__WEBPACK_IMPORTED_MODULE_4__["default"],
  cfrep: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  cstinfo: _models_customs_info__WEBPACK_IMPORTED_MODULE_6__["default"],
  cstitem: _models_customs_item__WEBPACK_IMPORTED_MODULE_7__["default"],
  es: _models_end_shipper__WEBPACK_IMPORTED_MODULE_9__["default"],
  evt: _models_event__WEBPACK_IMPORTED_MODULE_10__["default"],
  hook: _models_webhook__WEBPACK_IMPORTED_MODULE_26__["default"],
  ins: _models_insurance__WEBPACK_IMPORTED_MODULE_12__["default"],
  order: _models_order__WEBPACK_IMPORTED_MODULE_13__["default"],
  payload: _models_payload__WEBPACK_IMPORTED_MODULE_15__["default"],
  pickup: _models_pickup__WEBPACK_IMPORTED_MODULE_16__["default"],
  pickuprate: _models_pickup_rate__WEBPACK_IMPORTED_MODULE_17__["default"],
  pl: _models_postage_label__WEBPACK_IMPORTED_MODULE_18__["default"],
  plrep: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  prcl: _models_parcel__WEBPACK_IMPORTED_MODULE_14__["default"],
  rate: _models_rate__WEBPACK_IMPORTED_MODULE_19__["default"],
  refrep: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  rfnd: _models_refund__WEBPACK_IMPORTED_MODULE_20__["default"],
  sf: _models_scan_form__WEBPACK_IMPORTED_MODULE_22__["default"],
  shp: _models_shipment__WEBPACK_IMPORTED_MODULE_23__["default"],
  shpinvrep: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  shprep: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  trk: _models_tracker__WEBPACK_IMPORTED_MODULE_24__["default"],
  trkrep: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  user: _models_user__WEBPACK_IMPORTED_MODULE_25__["default"]
};

/**
 * A map of EasyPost services available to the client.
 */
const RESOURCES = {
  Address: _models_address__WEBPACK_IMPORTED_MODULE_0__["default"],
  ApiKey: _models_api_key__WEBPACK_IMPORTED_MODULE_1__["default"],
  Batch: _models_batch__WEBPACK_IMPORTED_MODULE_2__["default"],
  Brand: _models_brand__WEBPACK_IMPORTED_MODULE_3__["default"],
  CarrierAccount: _models_carrier_account__WEBPACK_IMPORTED_MODULE_4__["default"],
  CarrierType: _models_carrier_type__WEBPACK_IMPORTED_MODULE_5__["default"],
  CustomsInfo: _models_customs_info__WEBPACK_IMPORTED_MODULE_6__["default"],
  CustomsItem: _models_customs_item__WEBPACK_IMPORTED_MODULE_7__["default"],
  EasyPostObject: _models_easypost_object__WEBPACK_IMPORTED_MODULE_8__["default"],
  EndShipper: _models_end_shipper__WEBPACK_IMPORTED_MODULE_9__["default"],
  Event: _models_event__WEBPACK_IMPORTED_MODULE_10__["default"],
  Form: _models_form__WEBPACK_IMPORTED_MODULE_11__["default"],
  Insurance: _models_insurance__WEBPACK_IMPORTED_MODULE_12__["default"],
  Order: _models_order__WEBPACK_IMPORTED_MODULE_13__["default"],
  Parcel: _models_parcel__WEBPACK_IMPORTED_MODULE_14__["default"],
  Payload: _models_payload__WEBPACK_IMPORTED_MODULE_15__["default"],
  Pickup: _models_pickup__WEBPACK_IMPORTED_MODULE_16__["default"],
  PickupRate: _models_pickup_rate__WEBPACK_IMPORTED_MODULE_17__["default"],
  PostageLabel: _models_postage_label__WEBPACK_IMPORTED_MODULE_18__["default"],
  Rate: _models_rate__WEBPACK_IMPORTED_MODULE_19__["default"],
  Refund: _models_refund__WEBPACK_IMPORTED_MODULE_20__["default"],
  Report: _models_report__WEBPACK_IMPORTED_MODULE_21__["default"],
  ScanForm: _models_scan_form__WEBPACK_IMPORTED_MODULE_22__["default"],
  Shipment: _models_shipment__WEBPACK_IMPORTED_MODULE_23__["default"],
  Tracker: _models_tracker__WEBPACK_IMPORTED_MODULE_24__["default"],
  User: _models_user__WEBPACK_IMPORTED_MODULE_25__["default"],
  Webhook: _models_webhook__WEBPACK_IMPORTED_MODULE_26__["default"]
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The base class for all EasyPost client library services.
 * @param {EasyPostClient} easypostClient The {@link EasyPostClient} instance to use for API calls.
 */
class BaseService {
  /**
   * Converts a JSON response and all its nested elements to associated {@link EasyPostObject}-based class instances.
   * @internal
   * @param {*} response The JSON response to convert (usually a `Map` or `Array`).
   * @param {*} params The parameters passed when fetching the response
   * @returns {*} An {@link EasyPostObject}-based class instance or an `Array` of {@link EasyPostObject}-based class instances.
   */
  static _convertToEasyPostObject(response, params) {
    if (Array.isArray(response)) {
      return response.map(value => {
        if (typeof value === 'object') {
          return this._convertToEasyPostObject(value, params);
        }
        return value;
      });
    }
    if (typeof response === 'object' && response !== null) {
      let classObject;
      if (RESOURCES[response.object] !== undefined) {
        classObject = new RESOURCES[response.object]();
      } else if (response.id !== undefined && EASYPOST_OBJECT_ID_PREFIX_TO_CLASS_NAME_MAP[response.id.substr(0, response.id.indexOf('_'))] !== undefined) {
        const className = response.id.substr(0, response.id.indexOf('_'));
        classObject = new EASYPOST_OBJECT_ID_PREFIX_TO_CLASS_NAME_MAP[className]();
      } else {
        classObject = new _models_easypost_object__WEBPACK_IMPORTED_MODULE_8__["default"]();
      }
      Object.keys(response).forEach(key => {
        classObject[key] = this._convertToEasyPostObject(response[key], params);
      });
      classObject._params = params;
      return classObject;
    }
    return response;
  }

  /**
   * Creates an EasyPost Object via the API.
   * @internal
   * @param {string} url The URL to send the API request to.
   * @param {Object} params The parameters to send with the API request.
   * @returns {EasyPostObject|Promise<never>} The created {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async _create(url, params) {
    try {
      const response = await easypostClient._post(url, params);
      return this._convertToEasyPostObject(response.body, params);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve a list of records from the API.
   * @internal
   * @param {string} url The URL to send the API request to.
   * @param {Object} [params] The parameters to send with the API request.
   * @returns {EasyPostObject|EasyPostObject[]|Promise<never>} The retrieved {@link EasyPostObject}-based class instance(s), or a `Promise` that rejects with an error.
   */
  static async _all(url, params = {}) {
    try {
      // eslint-disable-next-line no-param-reassign
      const response = await easypostClient._get(url, params);
      return this._convertToEasyPostObject(response.body, params);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve a record from the API.
   * @internal
   * @param {string} url The URL to send the API request to.
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async _retrieve(url) {
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve the next page of specific collection of object
   * @internal
   * @param {string} url The URL to send the API request to.
   * @param {Object} collection The collection of a specific object.
   * @param {Number} pageSize The number of records to return on each page.
   * @param {Object} optionalParams The optional param for additional value in the query string.
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   * TODO: Implement this function in EndShippers and Batches once the API supports them properly.
   */
  static async _getNextPage(url, key, collection, pageSize = null, optionalParams = {}) {
    var _ref, _collection$_params, _defaultParams$page_s;
    const collectionArray = collection[key];
    if (collectionArray == undefined || collectionArray.length == 0 || !collection.has_more) {
      throw new _errors_general_end_of_pagination_error__WEBPACK_IMPORTED_MODULE_27__["default"]();
    }
    const defaultParams = (_ref = (_collection$_params = collection._params) !== null && _collection$_params !== void 0 ? _collection$_params : collectionArray[0]._params) !== null && _ref !== void 0 ? _ref : {};
    const params = {
      ...defaultParams,
      page_size: (_defaultParams$page_s = defaultParams.page_size) !== null && _defaultParams$page_s !== void 0 ? _defaultParams$page_s : pageSize,
      before_id: collectionArray[collectionArray.length - 1].id,
      ...optionalParams
    };
    const response = await this._all(url, params);
    if (response == undefined || response[key].length == 0) {
      throw new _errors_general_end_of_pagination_error__WEBPACK_IMPORTED_MODULE_27__["default"]();
    }
    return response;
  }
});

/***/ }),

/***/ "./services/batch_service.js":
/*!***********************************!*\
  !*** ./services/batch_service.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DEFAULT_LABEL_FORMAT: () => (/* binding */ DEFAULT_LABEL_FORMAT),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

const DEFAULT_LABEL_FORMAT = 'pdf';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The BatchService class provides methods for interacting with EasyPost {@link Batch} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class BatchService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Batch batch}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-batch EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the batch to be created.
   * @returns {Batch} - The created batch.
   */
  static async create(params) {
    const url = 'batches';
    const wrappedParams = {
      batch: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Add {@link Shipment shipments} to a {@link Batch batch}.
   * See {@link https://www.easypost.com/docs/api/node#add-shipments-to-a-batch EasyPost API Documentation} for more information.
   * @param {string} id - The id of the batch to add shipments to.
   * @param {Array} shipmentIds - The ids of the shipments to add to the batch.
   * @returns {Batch} - The updated batch.
   */
  static async addShipments(id, shipmentIds) {
    const url = `batches/${id}/add_shipments`;
    const wrappedParams = {
      shipments: shipmentIds.map(s => ({
        id: s
      }))
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Removes {@link Shipment shipments} from a {@link Batch batch}.
   * See {@link https://www.easypost.com/docs/api/node#remove-shipments-from-a-batch EasyPost API Documentation} for more information.
   * @param {string} id - The id of the batch to remove shipments from.
   * @param {Array} shipmentIds - The ids of the shipments to remove from the batch.
   * @returns {Batch} - The updated batch.
   */
  static async removeShipments(id, shipmentIds) {
    const url = `batches/${id}/remove_shipments`;
    const wrappedParams = {
      shipments: shipmentIds.map(s => ({
        id: s
      }))
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Generate a label for a {@link Batch batch}.
   * See {@link https://www.easypost.com/docs/api/node#batch-labels EasyPost API Documentation} for more information.
   * @param {string} id - The id of the batch to generate a label for.
   * @param {string} fileFormat - The format of the label to generate. Defaults to 'pdf'.
   * @returns {Batch} - The updated batch.
   */
  static async generateLabel(id, fileFormat = DEFAULT_LABEL_FORMAT) {
    const url = `batches/${id}/label`;
    const wrappedParams = {
      file_format: fileFormat
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Create a {@link ScanForm scan form} for a {@link Batch batch}.
   * See {@link https://www.easypost.com/docs/api/node#manifesting-scan-form EasyPost API Documentation} for more information.
   * @param {string} id - The id of the batch to create a scan form for.
   * @returns {Batch} - The updated batch.
   */
  static async createScanForm(id) {
    const url = `batches/${id}/scan_form`;
    try {
      const response = await easypostClient._post(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Purchase a {@link Batch batch}.
   * See {@link https://www.easypost.com/docs/api/node#buy-a-batch EasyPost API Documentation} for more information.
   * @param {string} id - The id of the batch to purchase.
   * @returns {Batch} - The purchased batch.
   */
  static async buy(id) {
    const url = `batches/${id}/buy`;
    try {
      const response = await easypostClient._post(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve all {@link Batch batches} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#list-all-batches EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the list of batches.
   * @returns {Object} - An object containing a list of {@link Batch batches} and pagination information.
   */
  static async all(params = {}) {
    const url = 'batches';
    return this._all(url, params);
  }

  /**
   * Retrieve a {@link Batch batch} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-batch EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the batch to retrieve.
   * @returns {Batch} - The retrieved batch.
   */
  static async retrieve(id) {
    const url = `batches/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/beta_rate_service.js":
/*!***************************************!*\
  !*** ./services/beta_rate_service.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");


/**
 * @extends baseService
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient => class BetaRateService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Retrieve a list of stateless {@link Rate rates} based on the provided parameters.
   * @param {Object} params - Map of parameters for the API call
   * @returns {Rate[]} - List of stateless rates
   */
  static async retrieveStatelessRates(params) {
    const url = 'beta/rates';
    const wrappedParams = {
      shipment: params
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body.rates, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }
});

/***/ }),

/***/ "./services/beta_referral_customer_service.js":
/*!****************************************************!*\
  !*** ./services/beta_referral_customer_service.js ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient => class BetaReferralCustomerService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Add an existing Stripe payment method to a {@link User referral customer's} account.
   * @param {string} stripeCustomerId - The Stripe account's ID.
   * @param {string} paymentMethodReference - Reference of Stripe payment method.
   * @param {string} [priority] - Which priority to set the payment method to ('primary' or 'secondary').
   * @returns {Object} - A JSON object representing the payment method.
   */
  static async addPaymentMethod(stripeCustomerId, paymentMethodReference, priority = 'primary') {
    const wrappedParams = {
      payment_method: {
        stripe_customer_id: stripeCustomerId,
        payment_method_reference: paymentMethodReference,
        priority
      }
    };
    const url = 'beta/referral_customers/payment_method';
    const response = await easypostClient._post(url, wrappedParams);
    return response;
  }

  /**
   * Refund by amount for a recent payment.
   * @param {number} refundAmount - Amount to be refunded by cents.
   * @returns {Object} - A JSON object representing the refund.
   */
  static async refundByAmount(refundAmount) {
    const params = {
      refund_amount: refundAmount
    };
    const url = 'beta/referral_customers/refunds';
    const response = await easypostClient._post(url, params);
    return response;
  }

  /**
   * Refund a payment by a payment log ID.
   * @param {string} paymentLogId - ID of the payment log.
   * @returns {object} - Returns BetaPaymentRefund object.
   */
  static async refundByPaymentLog(paymentLogId) {
    const params = {
      payment_log_id: paymentLogId
    };
    const url = 'beta/referral_customers/refunds';
    const response = await easypostClient._post(url, params);
    return response;
  }
});

/***/ }),

/***/ "./services/billing_service.js":
/*!*************************************!*\
  !*** ./services/billing_service.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _errors_general_invalid_object_error__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../errors/general/invalid_object_error */ "./errors/general/invalid_object_error.js");
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");



/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The BillingService class provides methods for interacting with EasyPost's billing capabilities.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class BillingService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_2__["default"])(easypostClient) {
  /**
   * Fund your EasyPost wallet by charging your primary or secondary payment method on file.
   * See {@link https://www.easypost.com/docs/api/node#add-funds-to-your-wallet-one-time-charge EasyPost API Documentation} for more information.
   * @param {String} amount - The amount to charge to your payment method.
   * @param {String} priority - The priority of the payment method to charge. Can be either 'primary' or 'secondary'.
   */
  static async fundWallet(amount, priority = 'primary') {
    const paymentInfo = await this._getPaymentInfo(priority.toLowerCase());
    const endpoint = paymentInfo[0];
    const paymentMethodID = paymentInfo[1];
    const url = `${endpoint}/${paymentMethodID}/charges`;
    const wrappedParams = {
      amount
    };
    await easypostClient._post(url, wrappedParams);
  }

  /**
   * Delete a payment method from the current authenticated user's account.
   * See {@link https://www.easypost.com/docs/api/node#delete-a-payment-method EasyPost API Documentation} for more information.
   * @param {String} priority - The priority of the payment method to delete. Can be either 'primary' or 'secondary'.
   */
  static async deletePaymentMethod(priority) {
    const paymentInfo = await this._getPaymentInfo(priority.toLowerCase());
    const endpoint = paymentInfo[0];
    const paymentMethodID = paymentInfo[1];
    const url = `${endpoint}/${paymentMethodID}`;
    await easypostClient._delete(url);
  }

  /**
   * Retrieve all payment methods associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-payment-methods EasyPost API Documentation} for more information.
   * @returns {Object} - An object containing the payment methods associated with the current authenticated user.
   */
  static async retrievePaymentMethods() {
    const url = 'payment_methods';
    const res = await easypostClient._get(url);
    if (res.body.id === null) {
      throw new _errors_general_invalid_object_error__WEBPACK_IMPORTED_MODULE_1__["default"]({
        message: _constants__WEBPACK_IMPORTED_MODULE_0__["default"].NO_PAYMENT_METHODS
      });
    }
    return res.body;
  }

  /**
   * Get payment info (type of the payment method and ID of the payment method)
   * This function is intended for internal use only, please avoid using this function
   * @private
   * @param {String} priority - The priority of the payment method to retrieve. Can be either 'primary' or 'secondary'.
   * @returns {string[]} - An array of two strings, the first being the endpoint of the payment method and the second being the ID of the payment method.
   */
  static async _getPaymentInfo(priority) {
    const paymentMethods = await this.retrievePaymentMethods();
    const paymentMethodMap = {
      primary: 'primary_payment_method',
      secondary: 'secondary_payment_method'
    };
    const paymentMethodToUse = paymentMethodMap[priority];
    let paymentMethodID;
    let endpoint;
    const errorString = 'The chosen payment method is not valid. Please try again.';
    if (paymentMethodToUse !== undefined && paymentMethods[paymentMethodToUse] !== null) {
      paymentMethodID = paymentMethods[paymentMethodToUse].id;
      if (paymentMethodID.startsWith('card_')) {
        endpoint = 'credit_cards';
      } else if (paymentMethodID.startsWith('bank_')) {
        endpoint = 'bank_accounts';
      } else {
        throw new _errors_general_invalid_object_error__WEBPACK_IMPORTED_MODULE_1__["default"]({
          message: errorString
        });
      }
    } else {
      throw new _errors_general_invalid_object_error__WEBPACK_IMPORTED_MODULE_1__["default"]({
        message: errorString
      });
    }
    return [endpoint, paymentMethodID];
  }
});

/***/ }),

/***/ "./services/carrier_account_service.js":
/*!*********************************************!*\
  !*** ./services/carrier_account_service.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _errors_general_invalid_parameter_error__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../errors/general/invalid_parameter_error */ "./errors/general/invalid_parameter_error.js");



const util = __webpack_require__(/*! util */ "util");
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The CarrierAccountService class provides methods for interacting with EasyPost @{link CarrierAccount} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class CarrierAccountService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link CarrierAccount carrier account}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-carrier-account EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the carrier account to be created.
   * @returns {CarrierAccount} - The created carrier account.
   */
  static async create(params) {
    const carrierAccountType = params.type;
    if (!carrierAccountType) {
      throw new _errors_general_invalid_parameter_error__WEBPACK_IMPORTED_MODULE_2__["default"]({
        message: util.format(_constants__WEBPACK_IMPORTED_MODULE_1__["default"].MISSING_REQUIRED_PARAMETER, 'CarrierAccount type')
      });
    }
    const endpoint = this._selectCarrierAccountCreationEndpoint(carrierAccountType);
    const wrappedParams = {
      carrier_account: params
    };
    return this._create(endpoint, wrappedParams);
  }

  /**
   * Update a {@link CarrierAccount carrier account}.
   * See {@link https://www.easypost.com/docs/api/node#update-a-carrieraccount EasyPost API Documentation} for more information.
   * @param {string} id - The id of the carrier account to be updated.
   * @param {Object} params - Parameters for the carrier account to be updated.
   * @returns {CarrierAccount} - The updated carrier account.
   */
  static async update(id, params) {
    const url = `carrier_accounts/${id}`;
    const wrappedParams = {
      carrier_account: params
    };
    try {
      const response = await easypostClient._patch(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Delete a {@link CarrierAccount carrier account}.
   * See {@link https://www.easypost.com/docs/api/node#delete-a-carrier-account EasyPost API Documentation} for more information.
   * @param {string} id - The id of the carrier account to be deleted.
   * @returns {Promise|Promise<never>} - A promise that resolves when the carrier account has been deleted.
   */
  static async delete(id) {
    const url = `carrier_accounts/${id}`;
    try {
      await easypostClient._delete(url);
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Returns the correct carrier_account endpoint when creating a record based on the type.
   * @private
   * @param {string} carrierAccountType - The type of carrier account to be created.
   * @returns {string} - The endpoint to be used for the carrier account creation request.
   */
  static _selectCarrierAccountCreationEndpoint(carrierAccountType) {
    if (_constants__WEBPACK_IMPORTED_MODULE_1__["default"].CARRIER_ACCOUNTS_WITH_CUSTOM_WORKFLOWS.includes(carrierAccountType)) {
      return 'carrier_accounts/register';
    }
    return 'carrier_accounts';
  }

  /**
   * Retrieve all {@link CarrierAccount carrier accounts} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#list-all-carrier-accounts EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the list of carrier accounts.
   * @returns {Object} - An object containing a list of {@link CarrierAccount carrier accounts} and pagination information.
   */
  static async all(params = {}) {
    const url = 'carrier_accounts';
    return this._all(url, params);
  }

  /**
   * Retrieve a {@link CarrierAccount carrier account} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-carrieraccount EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the carrier account to retrieve.
   * @returns {CarrierAccount} - The retrieved carrier account.
   */
  static async retrieve(id) {
    const url = `carrier_accounts/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/carrier_metadata_service.js":
/*!**********************************************!*\
  !*** ./services/carrier_metadata_service.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");


/**
 * @extends baseService
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient => class CarrierMetadataService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Retrieve a list of carrier metadata based on the provided parameters.
   * @param {Array} carriers - List of carrier in string
   * @param {Array} type - List of types in string
   * @returns {Object[]} - List of carrier metadata
   */
  static async retrieve(carriers = null, types = null) {
    const url = 'metadata/carriers';
    const params = {
      ...(carriers && carriers.length > 0 && {
        carriers: carriers.join(',')
      }),
      ...(types && types.length > 0 && {
        types: types.join(',')
      })
    };
    try {
      const response = await easypostClient._get(url, params);
      return this._convertToEasyPostObject(response.body.carriers || [], params);
    } catch (e) {
      return Promise.reject(e);
    }
  }
});

/***/ }),

/***/ "./services/carrier_type_service.js":
/*!******************************************!*\
  !*** ./services/carrier_type_service.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The CarrierTypeService class provides methods for interacting with EasyPost {@link CarrierType} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class CarrierTypeService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Retrieve all {@link CarrierType carrier types} available to the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-available-carrier-types EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the list of carrier types.
   * @returns {CarrierType[]} - A list of {@link CarrierType carrier types}.
   */
  static async all(params = {}) {
    const url = 'carrier_types';
    try {
      const response = await easypostClient._get(url, params);
      return this._convertToEasyPostObject(response.body, params);
    } catch (e) {
      return Promise.reject(e);
    }
  }
});

/***/ }),

/***/ "./services/customs_info_service.js":
/*!******************************************!*\
  !*** ./services/customs_info_service.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The CustomsInfoService class provides methods for interacting with EasyPost {@link CustomsInfo} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class CustomsInfoService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link CustomsInfo customs info} record.
   * See {@link https://www.easypost.com/docs/api/node#create-a-customsinfo EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the customs info to be created.
   * @returns {CustomsInfo} - The created customs info.
   */
  static async create(params) {
    const url = 'customs_infos';
    const wrappedParams = {
      customs_info: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Retrieve a {@link CustomsInfo customs info} record by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-customsinfo EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the customs info to retrieve.
   * @returns {CustomsInfo} - The retrieved customs info.
   */
  static async retrieve(id) {
    const url = `customs_infos/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/customs_item_service.js":
/*!******************************************!*\
  !*** ./services/customs_item_service.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The CustomsItemService class provides methods for interacting with EasyPost {@link CustomsItem} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class CustomsItemService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link CustomsItem customs item}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-customsitem EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the customs item to be created.
   * @returns {CustomsItem} - The created customs item.
   */
  static async create(params) {
    const url = 'customs_items';
    const wrappedParams = {
      customs_item: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Retrieve a {@link CustomsItem customs item} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-customsitem EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the customs item to retrieve.
   * @returns {CustomsItem} - The retrieved customs item.
   */
  static async retrieve(id) {
    const url = `customs_items/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/end_shipper_service.js":
/*!*****************************************!*\
  !*** ./services/end_shipper_service.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The EndShipperService class provides methods for interacting with EasyPost {@link EndShipper} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class EndShipperService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create an {@link EndShipper end shipper}.
   * See {@link https://www.easypost.com/docs/api/node#create-an-endshipper EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the end shipper to be created.
   * @returns {EndShipper} - The created end shipper.
   */
  static async create(params) {
    const url = 'end_shippers';
    const wrappedParams = {
      address: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Update an {@link EndShipper end shipper}.
   * See {@link https://www.easypost.com/docs/api/node#update-an-endshipper EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the end shipper to update.
   * @param {Object} params - Parameters for the end shipper to be updated.
   * @returns {EndShipper} - The updated end shipper.
   */
  static async update(id, params) {
    const url = `end_shippers/${id}`;
    const wrappedParams = {
      address: params
    };
    try {
      const response = await easypostClient._put(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve an {@link EndShipper end shipper} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-endshipper EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the end shipper to retrieve.
   * @returns {EndShipper} - The retrieved end shipper.
   */
  static async retrieve(id) {
    const url = `end_shippers/${id}`;
    return this._retrieve(url);
  }

  /**
   * Retrieve all {@link EndShipper end shippers} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-endshippers EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the list of end shippers.
   * @returns {Object} - An object containing a list of {@link EndShipper end shippers} and pagination information.
   */
  static async all(params = {}) {
    const url = 'end_shippers';
    return this._all(url, params);
  }
});

/***/ }),

/***/ "./services/event_service.js":
/*!***********************************!*\
  !*** ./services/event_service.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The EventService class provides methods for interacting with EasyPost {@link Event} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class EventService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Retrieve all {@link Payload payloads} for an {@link Event event}.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-payloads EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the event to retrieve payloads for.
   * @returns {Payload[]} - A list of {@link Payload payloads} for the event.
   */
  static async retrieveAllPayloads(id) {
    const url = `events/${id}/payloads`;
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body.payloads);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve a specific {@link Payload payload} for an {@link Event event}.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-payload EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the event to retrieve the payload for.
   * @param {string} payloadId - The ID of the payload to retrieve.
   * @returns {Payload} - The {@link Payload payload} for the event.
   */
  static async retrievePayload(id, payloadId) {
    const url = `events/${id}/payloads/${payloadId}`;
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve all {@link Event events} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-events EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the list of events.
   * @returns {Object} - An object containing the list of {@link Event events} and pagination information.
   */
  static async all(params = {}) {
    const url = 'events';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Event collection.
   * @param {Object} events An object containing a list of {@link Event events} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(events, pageSize = null) {
    const url = 'events';
    return this._getNextPage(url, 'events', events, pageSize);
  }

  /**
   * Retrieve an {@link Event event} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-event EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the event to retrieve.
   * @returns {Event} - The retrieved event.
   */
  static async retrieve(id) {
    const url = `events/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/insurance_service.js":
/*!***************************************!*\
  !*** ./services/insurance_service.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The InsuranceService class provides methods for interacting with EasyPost {@link Insurance} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class InsuranceService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create an {@link Insurance insurance} record.
   * See {@link https://www.easypost.com/docs/api/node#create-an-insurance EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters for the insurance to be created.
   * @returns {Insurance} - The created insurance.
   */
  static async create(params) {
    const url = 'insurances';
    const wrappedParams = {
      insurance: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Retrieve all {@link Insurance} records associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-insurances EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the insurance records.
   * @returns {Object} - An object containing the list of {@link Insurance insurance} records and pagination information.
   */
  static async all(params = {}) {
    const url = 'insurances';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Insurance collection.
   * @param {Object} insurances An object containing a list of {@link Insurance insurances} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(insurances, pageSize = null) {
    const url = 'insurances';
    return this._getNextPage(url, 'insurances', insurances, pageSize);
  }

  /**
   * Retrieve an {@link Insurance insurance} record by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-insurance EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the insurance to retrieve.
   * @returns {Insurance} - The retrieved insurance.
   */
  static async retrieve(id) {
    const url = `insurances/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/order_service.js":
/*!***********************************!*\
  !*** ./services/order_service.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The OrderService class provides methods for interacting with EasyPost {@link Order} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class OrderService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create an {@link Order order}.
   * See {@link https://www.easypost.com/docs/api/node#create-an-order EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create an order with.
   * @returns {Order} - The created order.
   */
  static async create(params) {
    const url = 'orders';
    const wrappedParams = {
      order: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Purchase an {@link Order order}.
   * See {@link https://www.easypost.com/docs/api/node#buy-an-order EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the order to buy.
   * @param {string} carrier - The carrier to use for the order purchase.
   * @param {string} service - The service to use for the order purchase.
   * @returns {Order} - The purchased order.
   */
  static async buy(id, carrier, service) {
    const url = `orders/${id}/buy`;
    const wrappedParams = {
      carrier,
      service
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Get updated rates for an {@link Order order}.
   * See {@link https://www.easypost.com/docs/api/node#orders EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the order to get rates for.
   * @returns {Order} - The order with rates.
   */
  static async getRates(id) {
    const url = `orders/${id}/rates`;
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve an {@link Order order} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-an-order EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the order to retrieve.
   * @returns {Order} - The retrieved order.
   */
  static async retrieve(id) {
    const url = `orders/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/parcel_service.js":
/*!************************************!*\
  !*** ./services/parcel_service.js ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The ParcelService class provides methods for interacting with EasyPost {@link Parcel} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class ParcelService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Parcel parcel}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-parcel EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a parcel with.
   * @returns {Parcel} - The created parcel.
   */
  static async create(params) {
    const url = 'parcels';
    const wrappedParams = {
      parcel: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Retrieve a {@link Parcel parcel} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-parcel EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the parcel to retrieve.
   * @returns {Parcel} - The retrieved parcel.
   */
  static async retrieve(id) {
    const url = `parcels/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/pickup_service.js":
/*!************************************!*\
  !*** ./services/pickup_service.js ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The PickupService class provides methods for interacting with EasyPost {@link Pickup} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class PickupService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Pickup pickup}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-pickup EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a pickup with.
   * @returns {Pickup} - The created pickup.
   */
  static async create(params) {
    const url = 'pickups';
    const wrappedParams = {
      pickup: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Purchase a {@link Pickup pickup}.
   * See {@link https://www.easypost.com/docs/api/node#buy-a-pickup EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the pickup to purchase.
   * @param {string} carrier - The carrier to purchase the pickup with.
   * @param {string} service - The service to purchase the pickup with.
   * @returns {Pickup} - The purchased pickup.
   */
  static async buy(id, carrier, service) {
    const url = `pickups/${id}/buy`;
    const wrappedParams = {
      carrier,
      service
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Cancel a {@link Pickup pickup}.
   * See {@link https://www.easypost.com/docs/api/node#cancel-a-pickup EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the pickup to cancel.
   * @returns {Pickup} - The cancelled pickup.
   */
  static async cancel(id) {
    const url = `pickups/${id}/cancel`;
    try {
      const response = await easypostClient._post(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve all {@link Pickup pickups} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-pickups EasyPost API Documentation} for more information.
   * @param {Object} [params] - The parameters to filter the pickups by.
   * @returns {Object} - An object containing a list of {@link Pickup pickups} and pagination information.
   */
  static async all(params = {}) {
    const url = 'pickups';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Pickup collection.
   * @param {Object} pickups An object containing a list of {@link Pickup pickups} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(pickups, pageSize = null) {
    const url = 'pickups';
    return this._getNextPage(url, 'pickups', pickups, pageSize);
  }

  /**
   * Retrieve a {@link Pickup pickup} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-pickup EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the pickup to retrieve.
   * @returns {Pickup} - The retrieved pickup.
   */
  static async retrieve(id) {
    const url = `pickups/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/rate_service.js":
/*!**********************************!*\
  !*** ./services/rate_service.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The RateService class provides methods for interacting with EasyPost {@link Rate} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class RateService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Retrieve a {@link Rate rate} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#rates EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the rate to retrieve.
   * @returns {Rate} - The retrieved rate.
   */
  static async retrieve(id) {
    const url = `rates/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/referral_customer_service.js":
/*!***********************************************!*\
  !*** ./services/referral_customer_service.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var superagent__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! superagent */ "superagent");
/* harmony import */ var superagent__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(superagent__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _easypost__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../easypost */ "./easypost.js");
/* harmony import */ var _errors_api_external_api_error__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../errors/api/external_api_error */ "./errors/api/external_api_error.js");
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");





const util = __webpack_require__(/*! util */ "util");

/**
 * Get an instance of the EasyPostClient using the referral user's API key.
 * @private
 * @param {EasyPostClient} client - The EasyPostClient to copy.
 * @param {string} referralApiKey - The referral user's API key.
 * @returns {EasyPostClient} - An instance of the EasyPostClient.
 */
function _getReferralClient(client, referralApiKey) {
  return _easypost__WEBPACK_IMPORTED_MODULE_2__["default"].copyClient(client, {
    apiKey: referralApiKey
  });
}

/**
 * Get EasyPost's Stripe API key used to create credit cards on Stripe's servers.
 * @private
 * @param {EasyPostClient} easypostClient - The EasyPostClient to use.
 * @returns {string} - The Stripe API key.
 */
async function _getEasyPostStripeKey(easypostClient) {
  const url = 'partners/stripe_public_key';
  const response = await easypostClient._get(url);
  return response.body.public_key;
}

/**
 * Send the credit card details to Stripe to get a Stripe credit card token.
 * @private
 * @param {string} stripeKey - The Stripe API key.
 * @param {string} number - Credit card number.
 * @param {string} expirationMonth - Credit card expiration month.
 * @param {string} expirationYear - Credit card expiration year.
 * @param {string} cvc - Credit card CVC.
 * @returns {Promise<string>} - Stripe credit card token.
 */
async function _sendCardDetailsToStripe(stripeKey, number, expirationMonth, expirationYear, cvc) {
  // Stripe's endpoint requires form-encoded requests
  const url = `https://api.stripe.com/v1/tokens?card[number]=${number}&card[exp_month]=${expirationMonth}&card[exp_year]=${expirationYear}&card[cvc]=${cvc}`;
  const request = superagent__WEBPACK_IMPORTED_MODULE_0___default().post(url).set({
    Authorization: `Bearer ${stripeKey}`,
    'Content-Type': 'application/x-www-form-urlencoded'
  });
  try {
    const response = await request;
    return response.body.id;
  } catch (error) {
    throw new _errors_api_external_api_error__WEBPACK_IMPORTED_MODULE_3__["default"]({
      message: util.format(_constants__WEBPACK_IMPORTED_MODULE_1__["default"].EXTERNAL_API_CALL_FAILED, 'Stripe')
    });
  }
}

/**
 * Send the Stripe credit card token to EasyPost to add the card to the user's account.
 * @private
 * @param {EasyPostClient} client - The EasyPostClient to use.
 * @param {string} referralApiKey - The referral user's production API key.
 * @param {string} stripeCreditCardToken - Stripe credit card token.
 * @param {string} priority - Whether to add the card as the 'primary' or 'secondary' card.
 * @returns {Object} - Response body (EasyPost payment method object).
 */
async function _sendCardDetailsToEasyPost(client, referralApiKey, stripeCreditCardToken, priority) {
  const _client = _getReferralClient(client, referralApiKey);
  const url = 'credit_cards';
  const params = {
    credit_card: {
      stripe_object_id: stripeCreditCardToken,
      priority
    }
  };
  const response = await _client._post(url, params);
  return response.body;
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The ReferralCustomerService class provides methods for interacting with EasyPost {@link User referral customer} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class ReferralCustomerService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_4__["default"])(easypostClient) {
  /**
   * Create a {@link User referral customer}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-referral-customer EasyPost API Documentation} for more information.
   * @param {Object} params - The referral customer's information.
   * @returns {User} - The newly created referral customer.
   */
  static async create(params) {
    const url = 'referral_customers';
    const wrappedParams = {
      user: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Update a {@link User referral customer's} email address.
   * See {@link https://www.easypost.com/docs/api/node#update-a-referral-customer EasyPost API Documentation} for more information.
   * @param {string} referralUserId - The ID of the referral customer to update.
   * @param {string} email - The new email address.
   * @returns {boolean} - Returns true if the referral was updated successfully, false otherwise.
   */
  static async updateEmail(referralUserId, email) {
    const url = `referral_customers/${referralUserId}`;
    const wrappedParams = {
      user: {
        email
      }
    };
    await easypostClient._put(url, wrappedParams); // will throw if there's an error

    return true;
  }

  /**
   * Add a credit card to a {@link User referral customer's} account.
   * See {@link https://www.easypost.com/docs/api/node#create-credit-card EasyPost API Documentation} for more information.
   * @param {string} referralApiKey - The referral customer's production API key.
   * @param {string} number - The credit card number.
   * @param {string} expirationMonth - The credit card expiration month.
   * @param {string} expirationYear - The credit card expiration year.
   * @param {string} cvc - The credit card CVC.
   * @param {string} priority - Whether to add the card as 'primary' or 'secondary' payment method (defaults to 'primary').
   * @returns {Object} - An object representing the newly-added credit card.
   */
  static async addCreditCard(referralApiKey, number, expirationMonth, expirationYear, cvc, priority = 'primary') {
    const stripeKey = await _getEasyPostStripeKey(easypostClient); // will throw if there's an error

    const stripeCreditCardId = await _sendCardDetailsToStripe(stripeKey, number, expirationMonth, expirationYear, cvc); // will throw if there's an error

    const paymentMethod = await _sendCardDetailsToEasyPost(easypostClient, referralApiKey, stripeCreditCardId, priority); // will throw if there's an error

    return paymentMethod;
  }

  /**
   * Retrieve all {@link User referral customers} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-referral-customers EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the referral customers by.
   * @returns {Object} - An object containing a list of {@link User referral customers} and pagination information.
   */
  static async all(params = {}) {
    const url = 'referral_customers';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Referral Customer collection.
   * @param {Object} referralCustomers An object containing a list of {@link referral referralCustomers} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(referralCustomers, pageSize = null) {
    const url = 'referral_customers';
    return this._getNextPage(url, 'referral_customers', referralCustomers, pageSize);
  }
});

/***/ }),

/***/ "./services/refund_service.js":
/*!************************************!*\
  !*** ./services/refund_service.js ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The RefundService class provides methods for interacting with EasyPost {@link Refund} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class RefundService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Refund refund}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-refund EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a refund with.
   * @returns {Refund} - The created refund.
   */
  static async create(params) {
    const url = 'refunds';
    const wrappedParams = {
      refund: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Retrieve all {@link Refund refunds} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-refunds EasyPost API Documentation} for more information.
   * @param {Object} [params] - The parameters to filter the refunds by.
   * @returns {Object} - An object containing the list of {@link Refund refunds} and pagination information.
   */
  static async all(params = {}) {
    const url = 'refunds';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Refund collection.
   * @param {Object} refunds An object containing a list of {@link Refund refunds} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(refunds, pageSize = null) {
    const url = 'refunds';
    return this._getNextPage(url, 'refunds', refunds, pageSize);
  }

  /**
   * Retrieve a {@link Refund refund} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-refund EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the refund to retrieve.
   * @returns {Refund} - The retrieved refund.
   */
  static async retrieve(id) {
    const url = `refunds/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/report_service.js":
/*!************************************!*\
  !*** ./services/report_service.js ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The ReportService class provides methods for interacting with EasyPost {@link Report} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class ReportService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Report report}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-report EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a report with.
   * @returns {Report} - The created report.
   */
  static async create(params) {
    const url = `reports/${params.type}`;
    return this._create(url, params);
  }

  /**
   * Retrieve all {@link Report reports} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-reports EasyPost API Documentation} for more information.
   * @param {Object} [params] - The parameters to filter the reports by.
   * @returns {Object} - An object containing the list of {@link Report reports} and pagination information.
   */
  static async all(params = {}) {
    const type = params.type;
    const url = `reports/${type}`;

    // delete "type" from params, so it doesn't get sent to the API
    // eslint-disable-next-line no-param-reassign
    delete params.type;
    try {
      const response = await easypostClient._get(url, params);
      // we want to add it back in here so that it can be used in the
      // "getNextPage" call below
      const responseObject = this._convertToEasyPostObject(response.body, {
        ...params,
        type
      });
      return responseObject;
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve the next page of Report collection.
   * @param {Object} reports An object containing a list of {@link Report reports} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(reports, pageSize = null) {
    const url = `reports/${reports.reports[0]._params.type}`;
    return this._getNextPage(url, 'reports', reports, pageSize);
  }

  /**
   * Retrieve a {@link Report report} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-report EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the report to retrieve.
   * @returns {Report} - The retrieved report.
   */
  static async retrieve(id) {
    const url = `reports/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/scan_form_service.js":
/*!***************************************!*\
  !*** ./services/scan_form_service.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The ScanFormService class provides methods for interacting with EasyPost {@link ScanForm} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class ScanFormService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link ScanForm scan form}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-scanform EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a scan form with.
   * @returns {ScanForm} - The created scan form.
   */
  static async create(params) {
    const url = 'scan_forms';

    // wraps up params in `shipments` if the user didn't do it
    // turn a list of shipment objects into a map of shipment ids
    if (params.shipments) {
      // eslint-disable-next-line no-param-reassign
      params.shipments = params.shipments.map(s => {
        if (typeof s === 'string') {
          return {
            id: s
          };
        }
        return {
          id: s.id
        };
      });
    }
    const wrappedParams = {
      scan_form: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Retrieve all {@link ScanForm scan forms} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-scanforms EasyPost API Documentation} for more information.
   * @param {Object} [params] - The parameters to filter the scan forms by.
   * @returns {Object} - An object containing the list of {@link ScanForm scan forms} and pagination information.
   */
  static async all(params = {}) {
    const url = 'scan_forms';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of ScanForm collection.
   * @param {Object} scanforms An object containing a list of {@link ScanForm scanforms} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(scanforms, pageSize = null) {
    const url = 'scan_forms';
    return this._getNextPage(url, 'scan_forms', scanforms, pageSize);
  }

  /**
   * Retrieve a {@link ScanForm scan form} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-scanform EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the scan form to retrieve.
   * @returns {ScanForm} - The retrieved scan form.
   */
  static async retrieve(id) {
    const url = `scan_forms/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/shipment_service.js":
/*!**************************************!*\
  !*** ./services/shipment_service.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");


/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The ShipmentService class provides methods for interacting with EasyPost {@link Shipment} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class ShipmentService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_1__["default"])(easypostClient) {
  /**
   * Create a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-shipment EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a shipment with.
   * @returns {Shipment} - The created shipment.
   */
  static async create(params) {
    const url = 'shipments';
    const wrappedParams = {
      shipment: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Purchase a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#buy-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to purchase.
   * @param {Rate} rate - The rate to purchase the shipment with.
   * @param {number|null} [insuranceAmount] - The amount of insurance to purchase for the shipment.
   * @param {string|null} [endShipperId] - The ID of the end shipper to purchase the shipment with.
   * @returns {Shipment} - The purchased shipment.
   */
  static async buy(id, rate, insuranceAmount = null, endShipperId = null) {
    let rateId = rate;
    if (typeof rate === 'object') {
      rateId = rate.id;
    }
    const url = `shipments/${id}/buy`;
    const wrappedParams = {
      rate: {
        id: rateId
      }
    };
    if (insuranceAmount) {
      wrappedParams.insurance = insuranceAmount;
    }
    if (endShipperId) {
      wrappedParams.end_shipper_id = endShipperId;
    }
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Convert the label format of a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#convert-the-label-format-of-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to convert the label format of.
   * @param {string} format - The format to convert the label to.
   * @returns {Shipment} - The shipment with the converted label format.
   */
  static async convertLabelFormat(id, format) {
    const url = `shipments/${id}/label`;
    const wrappedParams = {
      file_format: format
    };
    try {
      const response = await easypostClient._get(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Regenerate {@link Rate rates} for a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#regenerate-rates-for-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to regenerate rates for.
   * @returns {Shipment} - The shipment with regenerated rates.
   */
  static async regenerateRates(id) {
    const url = `shipments/${id}/rerate`;
    const wrappedParams = {};
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Get SmartRates for a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-time-in-transit-statistics-across-all-rates-for-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to get SmartRates for.
   * @returns {Rate[]} - The SmartRates for the shipment.
   */
  static async getSmartRates(id) {
    const url = `shipments/${id}/smartrate`;
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body.result);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Insure a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#insure-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to insure.
   * @param {number|string} amount - The amount to insure the shipment for.
   * @returns {Shipment} - The insured shipment.
   */
  static async insure(id, amount) {
    const url = `shipments/${id}/insure`;
    const wrappedParams = {
      amount
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Generate a form for a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#create-form EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to generate a form for.
   * @param {string} formType - The type of form to generate.
   * @param {Map} [formOptions] - Options for the form.
   * @returns {Shipment} - The shipment with the generated form attached.
   */
  static async generateForm(id, formType, formOptions = {}) {
    const url = `shipments/${id}/forms`;
    const wrappedParams = {
      form: {
        ...formOptions,
        type: formType
      }
    };
    try {
      const response = await easypostClient._post(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Refund a {@link Shipment shipment}.
   * See {@link https://www.easypost.com/docs/api/node#refund-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to refund.
   * @returns {Shipment} - The refunded shipment.
   */
  static async refund(id) {
    const url = `shipments/${id}/refund`;
    try {
      const response = await easypostClient._post(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Get the lowest SmartRate of a shipment.
   * @param {string} id - The ID of the shipment to get the lowest SmartRate of.
   * @param {number} deliveryDays - The number of days the shipment will take to deliver.
   * @param {string} deliveryAccuracy - The accuracy of the delivery days.
   * @returns {Rate} - The lowest SmartRate of the shipment.
   */
  static async lowestSmartRate(id, deliveryDays, deliveryAccuracy) {
    const smartRates = await this.getSmartRates(id);
    return _constants__WEBPACK_IMPORTED_MODULE_0__["default"].Utils.getLowestSmartRate(smartRates, deliveryDays, deliveryAccuracy.toLowerCase());
  }

  /**
   * Retrieve all {@link Shipment shipments} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-shipments EasyPost API Documentation} for more information.
   * @param {Object} [params] - Parameters to filter the shipments by.
   * @returns {Object} - An object containing a list of {@link Shipment shipments} and pagination information.
   */
  static async all(params = {}) {
    const url = 'shipments';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Shipment collection.
   * @param {Object} shipments An object containing a list of {@link Shipment shipments} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(shipments, pageSize = null) {
    const url = 'shipments';
    return this._getNextPage(url, 'shipments', shipments, pageSize);
  }

  /**
   * Retrieve a {@link Shipment shipment} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-shipment EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the shipment to retrieve.
   * @returns {Shipment} - The shipment with the given ID.
   */
  static async retrieve(id) {
    const url = `shipments/${id}`;
    return this._retrieve(url);
  }

  /**
   * Retrieves the estimated delivery date of each Rate via SmartRate.
   * @param {string} id
   * @param {string} plannedShipDate
   * @returns {Array} - An array of the estimated delivery date and rates.
   */
  static async retrieveEstimatedDeliveryDate(id, plannedShipDate) {
    const url = `shipments/${id}/smartrate/delivery_date`;
    const params = {
      planned_ship_date: plannedShipDate
    };
    try {
      var _response$body$rates;
      const response = await easypostClient._get(url, params);
      return this._convertToEasyPostObject((_response$body$rates = response.body.rates) !== null && _response$body$rates !== void 0 ? _response$body$rates : [], params);
    } catch (e) {
      return Promise.reject(e);
    }
  }
});

/***/ }),

/***/ "./services/tracker_service.js":
/*!*************************************!*\
  !*** ./services/tracker_service.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The TrackerService class provides methods for interacting with EasyPost {@link Tracker} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class TrackerService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Tracker tracker}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-tracker EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a tracker with.
   * @returns {Tracker} - The created tracker.
   */
  static async create(params) {
    const url = 'trackers';
    const wrappedParams = {
      tracker: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Create multiple {@link Tracker trackers} in a single request.
   * See {@link https://www.easypost.com/docs/api/node#trackers EasyPost API Documentation} for more information.
   * @param {Object} [params] - The parameters to create trackers with.
   */
  static async createList(params = {}) {
    const newParams = {
      trackers: params
    };
    const url = 'trackers/create_list';
    await easypostClient._post(url, newParams);
  }

  /**
   * Retrieve all {@link Tracker trackers} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-list-of-trackers EasyPost API Documentation} for more information.
   * @param {Object} [params] - The parameters to filter the trackers by.
   * @returns {Object} - An object containing the list of {@link Tracker trackers} and pagination information.
   */
  static async all(params = {}) {
    const url = 'trackers';
    return this._all(url, params);
  }

  /**
   * Retrieve the next page of Tracker collection.
   * @param {Object} trackers An object containing a list of {@link Tracker trackers} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(trackers, pageSize = null) {
    const url = 'trackers';
    return this._getNextPage(url, 'trackers', trackers, pageSize);
  }

  /**
   * Retrieve a {@link Tracker tracker} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-tracker EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the tracker to retrieve.
   * @returns {Tracker} - The retrieved tracker.
   */
  static async retrieve(id) {
    const url = `trackers/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./services/user_service.js":
/*!**********************************!*\
  !*** ./services/user_service.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The UserService class provides methods for interacting with EasyPost {@link User} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class UserService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link User child user}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-child-user EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a child user with.
   * @returns {User} - The created child user.
   */
  static async create(params) {
    const url = 'users';
    const wrappedParams = {
      user: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Update a {@link User user}.
   * See {@link https://www.easypost.com/docs/api/node#update-a-user EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the user to update (either the current authenticated user or a child user).
   * @param {Object} params - The parameters to update the user with.
   * @returns {User} - The updated user.
   */
  static async update(id, params) {
    const url = `users/${id}`;
    const wrappedParams = {
      user: params
    };
    try {
      const response = await easypostClient._patch(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve a {@link User child user}.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-user EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the child user to retrieve.
   * @returns {User} - The retrieved child user.
   */
  static async retrieve(id) {
    const url = `users/${id}`;
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve the {@link User current authenticated user}.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-user EasyPost API Documentation} for more information.
   * @returns {User} - The retrieved user.
   */
  static async retrieveMe() {
    const url = 'users';
    try {
      const response = await easypostClient._get(url);
      return this._convertToEasyPostObject(response.body);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Delete a {@link User child user}.
   * See {@link https://www.easypost.com/docs/api/node#delete-a-child-user EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the child user to delete.
   * @returns {Promise|Promise<never>} - A promise that resolves when the child user is deleted successfully.
   */
  static async delete(id) {
    const url = `users/${id}`;
    try {
      await easypostClient._delete(url);
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Update the brand of a {@link User user}.
   * See {@link https://www.easypost.com/docs/api/node#update-a-brand EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the user to update the brand of.
   * @param {Object} params - The parameters to update the brand with.
   * @returns {Brand} - The updated brand.
   */
  static async updateBrand(id, params) {
    const url = `users/${id}/brand`;
    const wrappedParams = {
      brand: params
    };
    try {
      const response = await easypostClient._patch(url, wrappedParams);
      return this._convertToEasyPostObject(response.body, wrappedParams);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve a paginated list of children user {@link User user}.
   * See {@link https://www.easypost.com/docs/api/node#child-users EasyPost API Documentation} for more information.
   * @param {Object} params - Parameters to filter the list of children users.
   * @returns {Object} - An object containing a list of {@link Children User} and pagination information.
   */
  static async allChildren(params) {
    const url = 'users/children';
    try {
      const response = await easypostClient._get(url, params);
      return this._convertToEasyPostObject(response.body, params);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve the next page of children collection.
   * @param {Object} children An object containing a list of {@link Children children} and pagination information.
   * @param {Number} pageSize The number of records to return on each page
   * @returns {EasyPostObject|Promise<never>} The retrieved {@link EasyPostObject}-based class instance, or a `Promise` that rejects with an error.
   */
  static async getNextPage(children, pageSize = null) {
    const url = 'users/children';
    return this._getNextPage(url, 'children', children, pageSize);
  }
});

/***/ }),

/***/ "./services/webhook_service.js":
/*!*************************************!*\
  !*** ./services/webhook_service.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _base_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base_service */ "./services/base_service.js");

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (easypostClient =>
/**
 * The WebhookService class provides methods for interacting with EasyPost {@link Webhook} objects.
 * @param {EasyPostClient} easypostClient - The pre-configured EasyPostClient instance to use for API requests with this service.
 */
class WebhookService extends (0,_base_service__WEBPACK_IMPORTED_MODULE_0__["default"])(easypostClient) {
  /**
   * Create a {@link Webhook webhook}.
   * See {@link https://www.easypost.com/docs/api/node#create-a-webhook EasyPost API Documentation} for more information.
   * @param {Object} params - The parameters to create a webhook with.
   * @returns {Webhook} - The created webhook.
   */
  static async create(params) {
    const url = 'webhooks';
    const wrappedParams = {
      webhook: params
    };
    return this._create(url, wrappedParams);
  }

  /**
   * Update a {@link Webhook webhook}.
   * A disabled webhook will be re-enabled if it is updated.
   * See {@link https://www.easypost.com/docs/api/node#update-a-webhook EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the webhook to update.
   * @param {Object} params - The parameters to update the webhook with.
   * @returns {Webhook} - The updated webhook.
   */
  static async update(id, params) {
    const url = `webhooks/${id}`;
    try {
      const response = await easypostClient._patch(url, params);
      return this._convertToEasyPostObject(response.body, params);
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Delete a {@link Webhook webhook}.
   * See {@link https://www.easypost.com/docs/api/node#delete-a-webhook EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the webhook to delete.
   * @returns {Promise|Promise<never>} - A promise that resolves if the webhook was successfully deleted.
   */
  static async delete(id) {
    const url = `webhooks/${id}`;
    try {
      await easypostClient._delete(url);
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  }

  /**
   * Retrieve all {@link Webhook webhooks} associated with the current authenticated user.
   * See {@link https://www.easypost.com/docs/api/node#list-a-webhooks EasyPost API Documentation} for more information.
   * @param {Object} [params]
   * @returns {Webhook[]}
   */
  static async all(params = {}) {
    const url = 'webhooks';
    return this._all(url, params);
  }

  /**
   * Retrieve a {@link Webhook webhook} by its ID.
   * See {@link https://www.easypost.com/docs/api/node#retrieve-a-webhook EasyPost API Documentation} for more information.
   * @param {string} id - The ID of the webhook to retrieve.
   * @returns {Webhook} - The retrieved webhook.
   */
  static async retrieve(id) {
    const url = `webhooks/${id}`;
    return this._retrieve(url);
  }
});

/***/ }),

/***/ "./utils/util.js":
/*!***********************!*\
  !*** ./utils/util.js ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ Utils)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./constants.js");
/* harmony import */ var _errors_general_filtering_error__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../errors/general/filtering_error */ "./errors/general/filtering_error.js");
/* harmony import */ var _errors_general_invalid_parameter_error__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../errors/general/invalid_parameter_error */ "./errors/general/invalid_parameter_error.js");
/* harmony import */ var _errors_general_signature_verification_error__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../errors/general/signature_verification_error */ "./errors/general/signature_verification_error.js");




const crypto = __webpack_require__(/*! crypto */ "crypto");
const util = __webpack_require__(/*! util */ "util");

/**
 * Utility class of various publicly-available helper functions.
 * @public
 * @type {Utils}
 */
class Utils {
  /**
   * Get the lowest SmartRate from a provided list of SmartRates.
   * @public
   * @param {Rate[]} smartrates - List of SmartRates to filter through
   * @param {number} deliveryDays - The maximum number of days allowed for delivery
   * @param {string} deliveryAccuracy - The target level of accuracy for the delivery days (e.g. 'percentile_50')
   * @returns {Rate} - The lowest SmartRate
   * @throws {FilteringError} - If no applicable rates are found
   * @throws {InvalidParameterError} - If the deliveryAccuracy value is invalid
   */
  getLowestSmartRate(smartrates, deliveryDays, deliveryAccuracy) {
    const validDeliveryAccuracyValues = new Set(['percentile_50', 'percentile_75', 'percentile_85', 'percentile_90', 'percentile_95', 'percentile_97', 'percentile_99']);
    let lowestSmartRate = null;
    const lowercaseDeliveryAccuracy = deliveryAccuracy.toLowerCase();
    if (!validDeliveryAccuracyValues.has(lowercaseDeliveryAccuracy)) {
      throw new _errors_general_invalid_parameter_error__WEBPACK_IMPORTED_MODULE_2__["default"]({
        message: `Invalid deliveryAccuracy value, must be one of: ${new Array(...validDeliveryAccuracyValues).join(', ')}`
      });
    }
    for (let i = 0; i < smartrates.length; i += 1) {
      const rate = smartrates[i];
      if (rate.time_in_transit[lowercaseDeliveryAccuracy] > parseInt(deliveryDays, 10)) {
        // eslint-disable-next-line no-continue
        continue;
      } else if (lowestSmartRate === null || parseFloat(rate.rate) < parseFloat(lowestSmartRate.rate)) {
        lowestSmartRate = rate;
      }
    }
    if (lowestSmartRate === null) {
      throw new _errors_general_filtering_error__WEBPACK_IMPORTED_MODULE_1__["default"]({
        message: util.format(_constants__WEBPACK_IMPORTED_MODULE_0__["default"].NO_OBJECT_FOUND, 'rates')
      });
    }
    return lowestSmartRate;
  }

  /**
   * Get the lowest rate from a provided list of rates.
   * @public
   * @param {Rate[]} rates - List of rates to filter through
   * @param {string[]} [carriers] - List of allowed carriers to filter by
   * @param {string[]} [services] - List of allowed services to filter by
   * @returns {Rate} - The lowest rate
   * @throws {FilteringError} - If no applicable rates are found
   */
  getLowestRate(rates, carriers = null, services = null) {
    if (carriers) {
      const carriersLower = carriers.map(carrier => carrier.toLowerCase());
      // eslint-disable-next-line no-param-reassign
      rates = rates.filter(rate => carriersLower.includes(rate.carrier.toLowerCase()));
    }
    if (services) {
      const servicesLower = services.map(service => service.toLowerCase());
      // eslint-disable-next-line no-param-reassign
      rates = rates.filter(rate => servicesLower.includes(rate.service.toLowerCase()));
    }
    if (rates.length === 0) {
      throw new _errors_general_filtering_error__WEBPACK_IMPORTED_MODULE_1__["default"]({
        message: util.format(_constants__WEBPACK_IMPORTED_MODULE_0__["default"].NO_OBJECT_FOUND, 'rates')
      });
    }
    return rates.reduce((lowest, rate) => {
      if (parseFloat(rate.rate) < parseFloat(lowest.rate)) {
        return rate;
      }
      return lowest;
    }, rates[0]);
  }

  /**
   * Validate a webhook by comparing the HMAC signature header sent from EasyPost to your shared secret.
   * If the signatures do not match, an error will be raised signifying the webhook either did not originate
   * from EasyPost or the secrets do not match. If the signatures do match, the `event_body` will be returned
   * as JSON.
   * @public
   * @param {buffer} eventBody - The raw body of the webhook event
   * @param {Object} headers - The headers of the webhook HTTP request
   * @param {string} webhookSecret - The webhook secret shared between EasyPost and your application
   * @returns {object} - The JSON-parsed webhook event body if the signature could be verified
   * @throws {SignatureVerificationError} - If the signature could not be verified
   */
  validateWebhook(eventBody, headers, webhookSecret) {
    var _ref, _headers$XHmacSigna;
    let webhook = {};
    const easypostHmacSignature = (_ref = (_headers$XHmacSigna = headers['X-Hmac-Signature']) !== null && _headers$XHmacSigna !== void 0 ? _headers$XHmacSigna : headers['x-hmac-signature']) !== null && _ref !== void 0 ? _ref : null;
    if (easypostHmacSignature != null) {
      const normalizedSecret = webhookSecret.normalize('NFKD');
      const encodedSecret = Buffer.from(normalizedSecret, 'utf8');
      const expectedSignature = crypto.createHmac('sha256', encodedSecret).update(eventBody, 'utf-8').digest('hex');
      const digest = `hmac-sha256-hex=${expectedSignature}`;
      try {
        if (crypto.timingSafeEqual(Buffer.from(easypostHmacSignature, 'utf8'), Buffer.from(digest, 'utf8'))) {
          webhook = JSON.parse(eventBody.toString());
        } else {
          throw new _errors_general_signature_verification_error__WEBPACK_IMPORTED_MODULE_3__["default"]({
            message: _constants__WEBPACK_IMPORTED_MODULE_0__["default"].WEBHOOK_DOES_NOT_MATCH
          });
        }
      } catch (e) {
        throw new _errors_general_signature_verification_error__WEBPACK_IMPORTED_MODULE_3__["default"]({
          message: _constants__WEBPACK_IMPORTED_MODULE_0__["default"].WEBHOOK_DOES_NOT_MATCH
        });
      }
    } else {
      throw new _errors_general_signature_verification_error__WEBPACK_IMPORTED_MODULE_3__["default"]({
        message: _constants__WEBPACK_IMPORTED_MODULE_0__["default"].INVALID_WEBHOOK_SIGNATURE
      });
    }
    return webhook;
  }
}

/***/ }),

/***/ "superagent":
/*!*****************************!*\
  !*** external "superagent" ***!
  \*****************************/
/***/ ((module) => {

module.exports = require("superagent");

/***/ }),

/***/ "uuid":
/*!***********************!*\
  !*** external "uuid" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("uuid");

/***/ }),

/***/ "crypto":
/*!*************************!*\
  !*** external "crypto" ***!
  \*************************/
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ "os":
/*!*********************!*\
  !*** external "os" ***!
  \*********************/
/***/ ((module) => {

module.exports = require("os");

/***/ }),

/***/ "util":
/*!***********************!*\
  !*** external "util" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("util");

/***/ }),

/***/ "../package.json":
/*!***********************!*\
  !*** ../package.json ***!
  \***********************/
/***/ ((module) => {

module.exports = JSON.parse('{"name":"@easypost/api","description":"EasyPost Node Client Library","version":"7.2.0","author":"Easypost Engineering <oss@easypost.com>","homepage":"https://easypost.com","bin":{"easypost":"./repl.js"},"repository":{"type":"git","url":"git://github.com/easypost/easypost-node.git"},"main":"index.js","types":"types/index.d.ts","license":"MIT","engines":{"node":">= 12.0"},"scripts":{"build":"webpack --config webpack.config.babel.js","clean":"rm -rf ./dist ./nyc_output ./node_modules/.cache ./coverage","coverage":"cross-env NODE_ENV=test nyc npm run test","docs":"./node_modules/.bin/jsdoc src/models src/services src/errors src/utils -d docs","format":"prettier --write .","formatCheck":"prettier --check .","lint":"eslint --ext .js,.ts .","lintFix":"eslint --ext .js,.ts --fix .","prepublishOnly":"npm run clean && npm run build && npm run test && npm run lint && npm run formatCheck","repl":"./repl.js --local easypost.js","scan":"npx audit-ci -m","test":"cross-env NODE_ENV=test mocha --timeout 10000 --require @babel/register --require ./test/helpers/common.js --recursive ./test","watch":"webpack --config webpack.config.babel.js --watch"},"dependencies":{"core-js":"~3.30.2","nodent-runtime":"~3.2.1","regenerator-runtime":"~0.13.11","source-map-support":"~0.5.21","superagent":"~8.0.9","uuid":"^9.0.0","yargs":"~17.7.2","yargs-parser":"~21.1.1"},"devDependencies":{"@babel/core":"^7.21.8","@babel/eslint-parser":"^7.21.8","@babel/plugin-proposal-class-properties":"^7.18.6","@babel/plugin-proposal-export-default-from":"^7.18.10","@babel/plugin-proposal-export-namespace-from":"^7.18.9","@babel/plugin-transform-react-constant-elements":"^7.21.3","@babel/plugin-transform-react-inline-elements":"^7.21.0","@babel/preset-env":"^7.21.5","@babel/register":"^7.21.0","@pollyjs/adapter-node-http":"^6.0.5","@pollyjs/core":"^6.0.5","@pollyjs/persister-fs":"^6.0.5","@typescript-eslint/eslint-plugin":"^5.59.5","@typescript-eslint/parser":"^5.59.5","audit-ci":"^6.6.1","babel-loader":"^8.2.5","babel-plugin-istanbul":"^6.1.1","babel-plugin-transform-export-extensions":"^6.22.0","babel-preset-minify":"^0.5.2","chai":"4.3.10","chai-as-promised":"^7.1.1","cross-env":"^7.0.3","eslint":"^8.40.0","eslint-config-prettier":"^8.8.0","eslint-import-resolver-webpack":"^0.13.2","eslint-plugin-babel":"^5.3.1","eslint-plugin-import":"^2.27.5","eslint-plugin-jest":"^27.2.1","eslint-plugin-jsx-a11y":"^6.7.1","eslint-plugin-react":"^7.32.1","jsdoc":"^4.0.2","mocha":"^10.2.0","nyc":"^15.1.0","prettier":"^2.8.8","typescript":"^4.9.5 || ~5.0.0","vows":"^0.8.3","webpack":"^5.76.3","webpack-cli":"^5.0.1","webpack-node-externals":"^3.0.0"}}');

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./easypost.js");
/******/ 	var __webpack_export_target__ = exports;
/******/ 	for(var i in __webpack_exports__) __webpack_export_target__[i] = __webpack_exports__[i];
/******/ 	if(__webpack_exports__.__esModule) Object.defineProperty(__webpack_export_target__, "__esModule", { value: true });
/******/ 	
/******/ })()
;
//# sourceMappingURL=easypost.js.map